#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

CL_INIT KFopen[] =
{
{ CL_FIXNUM, 17 }, /* 0 */
{ RT_CHAR_PTR, (long)"illegal option ~s" },
{ CL_FIXNUM, 47 }, /* 2 */
{ RT_CHAR_PTR, (long)"currently only strings can be used as filenames" },
{ CL_FIXNUM, 1 }, /* 4 */
{ RT_CHAR_PTR, (long)"r" },
{ CL_FIXNUM, 17 }, /* 6 */
{ RT_CHAR_PTR, (long)"~s does not exist" },
{ CL_FIXNUM, 2 }, /* 8 */
{ RT_CHAR_PTR, (long)"w+" },
{ CL_FIXNUM, 17 }, /* 10 */
{ RT_CHAR_PTR, (long)"can not create ~S" },
{ CL_FIXNUM, 17 }, /* 12 */
{ RT_CHAR_PTR, (long)"illegal option ~s" },
{ CL_FIXNUM, 22 }, /* 14 */
{ RT_CHAR_PTR, (long)"file already exists ~s" },
{ CL_FIXNUM, 2 }, /* 16 */
{ RT_CHAR_PTR, (long)"r+" },
{ CL_FIXNUM, 2 }, /* 18 */
{ RT_CHAR_PTR, (long)"a+" },
{ CL_FIXNUM, 2 }, /* 20 */
{ RT_CHAR_PTR, (long)"w+" },
{ CL_FIXNUM, 23 }, /* 22 */
{ RT_CHAR_PTR, (long)"unimplemented option ~S" },
{ CL_FIXNUM, 2 }, /* 24 */
{ RT_CHAR_PTR, (long)"r+" },
{ CL_FIXNUM, 15 }, /* 26 */
{ RT_CHAR_PTR, (long)"can not open ~S" },
};

static void Z57_get_io_file(CL_FORM *base, CL_FORM *display[]);

void Fopen(CL_FORM *base, int nargs)
{
	CL_FORM *display[1];
	BOOL supl_flags[3];
	static CL_FORM * keylist[] =
	{
		SYMBOL(Slisp, 153), /* DIRECTION */
		SYMBOL(Slisp, 155), /* IF-EXISTS */
		SYMBOL(Slisp, 162), /* IF-DOES-NOT-EXIST */
	};
	keysort(STACK(base, 1), nargs - 1, 3, keylist, supl_flags, FALSE);
	if(NOT(supl_flags[0]))
	{
		LOAD_SYMBOL(SYMBOL(Slisp, 152), STACK(base, 1)); /* INPUT */
	}
	if(NOT(supl_flags[1]))
	{
		LOAD_SYMBOL(SYMBOL(Slisp, 154), STACK(base, 2)); /* ERROR */
	}
	if(NOT(supl_flags[2]))
	{
		if(GET_SYMBOL(STACK(base, 1)) == SYMBOL(Slisp, 152) && CL_SYMBOLP(STACK(base, 1))) /* INPUT */
		{
			LOAD_SYMBOL(SYMBOL(Slisp, 154), STACK(base, 3)); /* ERROR */
		}
		else
		{
			if(GET_SYMBOL(STACK(base, 1)) == SYMBOL(Slisp, 156) && CL_SYMBOLP(STACK(base, 1))) /* OUTPUT */
			{
				LOAD_T(STACK(base, 4));
			}
			else
			{
				LOAD_NIL(STACK(base, 4));
			}
			if(CL_TRUEP(STACK(base, 4)))
			{
				bool_result = TRUE;
			}
			else
			{
				bool_result = GET_SYMBOL(STACK(base, 1)) == SYMBOL(Slisp, 157) && CL_SYMBOLP(STACK(base, 1)); /* IO */
			}
			if(bool_result)
			{
				if(GET_SYMBOL(STACK(base, 2)) == SYMBOL(Slisp, 158) && CL_SYMBOLP(STACK(base, 2))) /* OVERWRITE */
				{
					LOAD_T(STACK(base, 4));
				}
				else
				{
					LOAD_NIL(STACK(base, 4));
				}
				if(CL_TRUEP(STACK(base, 4)))
				{
					bool_result = TRUE;
				}
				else
				{
					bool_result = GET_SYMBOL(STACK(base, 2)) == SYMBOL(Slisp, 159) && CL_SYMBOLP(STACK(base, 2)); /* APPEND */
				}
				if(bool_result)
				{
					LOAD_SYMBOL(SYMBOL(Slisp, 154), STACK(base, 3)); /* ERROR */
				}
				else
				{
					LOAD_SYMBOL(SYMBOL(Slisp, 160), STACK(base, 3)); /* CREATE */
				}
			}
			else
			{
				if(GET_SYMBOL(STACK(base, 1)) == SYMBOL(Slisp, 161) && CL_SYMBOLP(STACK(base, 1))) /* PROBE */
				{
					LOAD_NIL(STACK(base, 3));
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KFopen[0], STACK(base, 4)); /* illegal option ~s */
					COPY(STACK(base, 1), STACK(base, 5));
					Ferror(STACK(base, 4), 2);
				}
			}
		}
	}
	{
		CONTENV new_cont;
		CL_FORM *caller_base;
		new_cont.bind_top = bind_top;
		new_cont.last = last_cont;
		LOAD_UNIQUE_TAG(STACK(base, 4));
		caller_base = (CL_FORM *)SETJMP(new_cont.jmp_buf);
		if(caller_base == NULL)
		{
			last_cont = &new_cont;
			LOAD_NIL(STACK(base, 5));
			LOAD_NIL(STACK(base, 6));
			if(CL_SMSTRP(STACK(base, 0)) || CL_STRINGP(STACK(base, 0)))
			{
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KFopen[2], STACK(base, 7)); /* currently only strings can be used as filenames */
				Ferror(STACK(base, 7), 1);
			}
			COPY(STACK(base, 0), STACK(base, 7));
			LOAD_SMSTR((CL_FORM *)&KFopen[4], STACK(base, 8)); /* r */
			c_fopen(STACK(base, 7));
			COPY(STACK(base, 7), STACK(base, 5));
			if(CL_TRUEP(STACK(base, 5)))
			{
			}
			else
			{
				if(GET_SYMBOL(STACK(base, 3)) == SYMBOL(Slisp, 154) && CL_SYMBOLP(STACK(base, 3))) /* ERROR */
				{
					LOAD_SMSTR((CL_FORM *)&KFopen[6], STACK(base, 7)); /* ~s does not exist */
					COPY(STACK(base, 0), STACK(base, 8));
					Ferror(STACK(base, 7), 2);
				}
				else
				{
					if(CL_TRUEP(STACK(base, 3)))
					{
						if(GET_SYMBOL(STACK(base, 3)) == SYMBOL(Slisp, 160) && CL_SYMBOLP(STACK(base, 3))) /* CREATE */
						{
							COPY(STACK(base, 0), STACK(base, 6));
							LOAD_SMSTR((CL_FORM *)&KFopen[8], STACK(base, 7)); /* w+ */
							c_fopen(STACK(base, 6));
							if(CL_TRUEP(STACK(base, 6)))
							{
							}
							else
							{
								LOAD_SMSTR((CL_FORM *)&KFopen[10], STACK(base, 7)); /* can not create ~S */
								COPY(STACK(base, 0), STACK(base, 8));
								Ferror(STACK(base, 7), 2);
							}
						}
						else
						{
							LOAD_SMSTR((CL_FORM *)&KFopen[12], STACK(base, 7)); /* illegal option ~s */
							COPY(STACK(base, 3), STACK(base, 8));
							Ferror(STACK(base, 7), 2);
						}
					}
					else
					{
						LOAD_NIL(STACK(base, 0));
						goto RETURN10;
					}
				}
			}
			if(GET_SYMBOL(STACK(base, 1)) == SYMBOL(Slisp, 152) && CL_SYMBOLP(STACK(base, 1))) /* INPUT */
			{
				LOAD_T(STACK(base, 7));
			}
			else
			{
				LOAD_NIL(STACK(base, 7));
			}
			if(CL_TRUEP(STACK(base, 7)))
			{
				bool_result = TRUE;
			}
			else
			{
				bool_result = GET_SYMBOL(STACK(base, 1)) == SYMBOL(Slisp, 161) && CL_SYMBOLP(STACK(base, 1)); /* PROBE */
			}
			if(bool_result)
			{
				if(CL_TRUEP(STACK(base, 6)))
				{
					COPY(STACK(base, 6), STACK(base, 7));
					COPY(STACK(base, 7), STACK(base, 8));
					stream_close(STACK(base, 8));
					COPY(STACK(base, 7), STACK(base, 9));
					Ffuncall(STACK(base, 8), 2);
					mv_count = 1;
					COPY(STACK(base, 0), STACK(base, 7));
					LOAD_SMSTR((CL_FORM *)&KFopen[24], STACK(base, 8)); /* r+ */
					c_fopen(STACK(base, 7));
					COPY(STACK(base, 7), STACK(base, 5));
				}
				if(CL_TRUEP(STACK(base, 5)))
				{
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KFopen[26], STACK(base, 7)); /* can not open ~S */
					COPY(STACK(base, 0), STACK(base, 8));
					Ferror(STACK(base, 7), 2);
				}
				COPY(STACK(base, 5), STACK(base, 7));
				COPY(STACK(base, 0), STACK(base, 8));
				make_file_input_stream(STACK(base, 7));
				if(GET_SYMBOL(STACK(base, 1)) == SYMBOL(Slisp, 161) && CL_SYMBOLP(STACK(base, 1))) /* PROBE */
				{
					COPY(STACK(base, 7), STACK(base, 8));
					COPY(STACK(base, 8), STACK(base, 9));
					stream_close(STACK(base, 9));
					COPY(STACK(base, 8), STACK(base, 10));
					Ffuncall(STACK(base, 9), 2);
					mv_count = 1;
				}
				COPY(STACK(base, 7), STACK(base, 0));
			}
			else
			{
				if(GET_SYMBOL(STACK(base, 1)) == SYMBOL(Slisp, 156) && CL_SYMBOLP(STACK(base, 1))) /* OUTPUT */
				{
					display[0] = STACK(base, 0);
					Z57_get_io_file(STACK(base, 7), display);
					COPY(STACK(base, 0), STACK(base, 8));
					make_file_output_stream(STACK(base, 7));
					COPY(STACK(base, 7), STACK(base, 0));
				}
				else
				{
					if(GET_SYMBOL(STACK(base, 1)) == SYMBOL(Slisp, 157) && CL_SYMBOLP(STACK(base, 1))) /* IO */
					{
						display[0] = STACK(base, 0);
						Z57_get_io_file(STACK(base, 7), display);
						COPY(STACK(base, 0), STACK(base, 8));
						make_file_io_stream(STACK(base, 7));
						COPY(STACK(base, 7), STACK(base, 0));
					}
					else
					{
						LOAD_NIL(STACK(base, 0));
					}
				}
			}
			RETURN10:;
			last_cont = new_cont.last;
		}
		else
		{
			last_cont = new_cont.last;
			if(EQ(STACK(caller_base, 0), STACK(base, 4)))
			{
				COPY(STACK(caller_base, 1), STACK(base, 0));
			}
			else
			{
				call_cont(caller_base);
			}
		}
	}
}

static void Z57_get_io_file(CL_FORM *base, CL_FORM *display[])
{
	if(CL_TRUEP(&display[0][5]))
	{
		COPY(&display[0][5], STACK(base, 0));
		c_fclose(STACK(base, 0));
		if(GET_SYMBOL(&display[0][2]) == SYMBOL(Slisp, 154) && CL_SYMBOLP(&display[0][2])) /* ERROR */
		{
			LOAD_SMSTR((CL_FORM *)&KFopen[14], STACK(base, 0)); /* file already exists ~s */
			COPY(&display[0][0], STACK(base, 1));
			Ferror(STACK(base, 0), 2);
		}
		else
		{
			if(GET_SYMBOL(&display[0][2]) == SYMBOL(Slisp, 158) && CL_SYMBOLP(&display[0][2])) /* OVERWRITE */
			{
				COPY(&display[0][0], STACK(base, 0));
				LOAD_SMSTR((CL_FORM *)&KFopen[16], STACK(base, 1)); /* r+ */
				c_fopen(STACK(base, 0));
			}
			else
			{
				if(GET_SYMBOL(&display[0][2]) == SYMBOL(Slisp, 159) && CL_SYMBOLP(&display[0][2])) /* APPEND */
				{
					COPY(&display[0][0], STACK(base, 0));
					LOAD_SMSTR((CL_FORM *)&KFopen[18], STACK(base, 1)); /* a+ */
					c_fopen(STACK(base, 0));
				}
				else
				{
					if(GET_SYMBOL(&display[0][2]) == SYMBOL(Slisp, 163) && CL_SYMBOLP(&display[0][2])) /* SUPERSEDE */
					{
						LOAD_T(STACK(base, 0));
					}
					else
					{
						LOAD_NIL(STACK(base, 0));
					}
					if(CL_TRUEP(STACK(base, 0)))
					{
						bool_result = TRUE;
					}
					else
					{
						bool_result = GET_SYMBOL(&display[0][2]) == SYMBOL(Slisp, 164) && CL_SYMBOLP(&display[0][2]); /* NEW-VERSION */
					}
					if(bool_result)
					{
						COPY(&display[0][0], STACK(base, 0));
						LOAD_SMSTR((CL_FORM *)&KFopen[20], STACK(base, 1)); /* w+ */
						c_fopen(STACK(base, 0));
					}
					else
					{
						if(CL_TRUEP(&display[0][2]))
						{
							LOAD_SMSTR((CL_FORM *)&KFopen[22], STACK(base, 0)); /* unimplemented option ~S */
							COPY(&display[0][2], STACK(base, 1));
							Ferror(STACK(base, 0), 2);
						}
						else
						{
							COPY(&display[0][4], STACK(base, 0));
							LOAD_NIL(STACK(base, 1));
							call_cont(STACK(base, 0));
						}
					}
				}
			}
		}
	}
	else
	{
		COPY(&display[0][6], STACK(base, 0));
	}
}
