#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

void Fsubseq(CL_FORM *base, int nargs)
{
	switch(nargs)
	{
		case 2:
		LOAD_NIL(STACK(base, 2));
		case 3:
		break;
		default:
		Labort(TOO_MANY_ARGS);
	}
	if(CL_CONSP(STACK(base, 0)) || CL_NILP(STACK(base, 0)))
	{
		COPY(STACK(base, 0), STACK(base, 3));
		raw_list_length(STACK(base, 3));
	}
	else
	{
		if(TYPE_OF(STACK(base, 0)) >= T_VEC_LO && TYPE_OF(STACK(base, 0)) <= T_VEC_HI)
		{
			LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 0))), STACK(base, 3));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 3)); /* ~a is not a sequence */
			COPY(STACK(base, 0), STACK(base, 4));
			Ferror(STACK(base, 3), 2);
		}
	}
	COPY(STACK(base, 1), STACK(base, 4));
	COPY(STACK(base, 2), STACK(base, 5));
	COPY(STACK(base, 3), STACK(base, 6));
	check_seq_start_end(STACK(base, 4));
	COPY(STACK(base, 4), STACK(base, 2));
	if(CL_TRUEP(STACK(base, 0)))
	{
		if(CL_CONSP(STACK(base, 0)))
		{
			list_subseq(STACK(base, 0));
		}
		else
		{
			if(TYPE_OF(STACK(base, 0)) >= T_VEC_LO && TYPE_OF(STACK(base, 0)) <= T_VEC_HI)
			{
				vector_subseq(STACK(base, 0));
			}
			else
			{
				COPY(SYMVAL(Slisp, 57), STACK(base, 4)); /* WRONG_TYPE */
				COPY(STACK(base, 0), STACK(base, 5));
				LOAD_SYMBOL(SYMBOL(Slisp, 36), STACK(base, 6)); /* SEQUENCE */
				Ferror(STACK(base, 4), 3);
			}
		}
	}
	else
	{
		LOAD_NIL(STACK(base, 0));
	}
}
