#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

void Fsubstitute(CL_FORM *base, int nargs)
{
	BOOL supl_flags[7];
	static CL_FORM * keylist[] =
	{
		SYMBOL(Slisp, 233), /* FROM-END */
		SYMBOL(Slisp, 217), /* TEST */
		SYMBOL(Slisp, 323), /* TEST-NOT */
		SYMBOL(Slisp, 165), /* START */
		SYMBOL(Slisp, 166), /* END */
		SYMBOL(Slisp, 392), /* COUNT */
		SYMBOL(Slisp, 139), /* KEY */
	};
	keysort(STACK(base, 3), nargs - 3, 7, keylist, supl_flags, FALSE);
	if(NOT(supl_flags[0]))
	{
		LOAD_NIL(STACK(base, 3));
	}
	if(NOT(supl_flags[1]))
	{
		LOAD_NIL(STACK(base, 4));
	}
	if(NOT(supl_flags[2]))
	{
		LOAD_NIL(STACK(base, 5));
	}
	if(NOT(supl_flags[3]))
	{
		LOAD_FIXNUM(0, STACK(base, 6));
	}
	if(NOT(supl_flags[4]))
	{
		LOAD_NIL(STACK(base, 7));
	}
	if(NOT(supl_flags[5]))
	{
		LOAD_NIL(STACK(base, 8));
	}
	if(NOT(supl_flags[6]))
	{
		LOAD_GLOBFUN(&CFidentity, STACK(base, 9));
	}
	if(CL_CONSP(STACK(base, 2)) || CL_NILP(STACK(base, 2)))
	{
		COPY(STACK(base, 2), STACK(base, 10));
		raw_list_length(STACK(base, 10));
	}
	else
	{
		if(TYPE_OF(STACK(base, 2)) >= T_VEC_LO && TYPE_OF(STACK(base, 2)) <= T_VEC_HI)
		{
			LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 2))), STACK(base, 10));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 10)); /* ~a is not a sequence */
			COPY(STACK(base, 2), STACK(base, 11));
			Ferror(STACK(base, 10), 2);
		}
	}
	COPY(STACK(base, 4), STACK(base, 11));
	COPY(STACK(base, 5), STACK(base, 12));
	if(CL_TRUEP(STACK(base, 11)))
	{
		bool_result = CL_TRUEP(STACK(base, 12));
	}
	else
	{
		bool_result = FALSE;
	}
	if(bool_result)
	{
		LOAD_SMSTR((CL_FORM *)&KClisp[36], STACK(base, 13)); /* The TEST argument and the TEST-NOT argument are both set */
		Ferror(STACK(base, 13), 1);
	}
	else
	{
		if(CL_TRUEP(STACK(base, 11)))
		{
			COPY(STACK(base, 11), STACK(base, 4));
		}
		else
		{
			if(CL_TRUEP(STACK(base, 12)))
			{
				COPY(STACK(base, 12), STACK(base, 13));
				Fcomplement(STACK(base, 13));
				COPY(STACK(base, 13), STACK(base, 4));
			}
			else
			{
				static GLOBAL_FUNARG extern_closure = {Feql, 2};
				LOAD_GLOBFUN(&extern_closure, STACK(base, 4));
			}
		}
	}
	COPY(STACK(base, 6), STACK(base, 11));
	COPY(STACK(base, 7), STACK(base, 12));
	COPY(STACK(base, 10), STACK(base, 13));
	check_seq_start_end(STACK(base, 11));
	COPY(STACK(base, 11), STACK(base, 7));
	COPY(STACK(base, 8), STACK(base, 11));
	COPY(STACK(base, 10), STACK(base, 12));
	if(CL_FIXNUMP(STACK(base, 11)))
	{
		COPY(STACK(base, 11), STACK(base, 13));
		Fplusp(STACK(base, 13));
		if(CL_TRUEP(STACK(base, 13)))
		{
			COPY(STACK(base, 11), STACK(base, 8));
		}
		else
		{
			LOAD_FIXNUM(0, STACK(base, 8));
		}
	}
	else
	{
		if(CL_TRUEP(STACK(base, 11)))
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[34], STACK(base, 13)); /* ~S should be an INTEGER at least 0 and no more than 16777214 */
			COPY(STACK(base, 11), STACK(base, 14));
			Ferror(STACK(base, 13), 2);
		}
		else
		{
			COPY(STACK(base, 12), STACK(base, 8));
		}
	}
	if(CL_TRUEP(STACK(base, 3)))
	{
		COPY(STACK(base, 2), STACK(base, 11));
		if(CL_CONSP(STACK(base, 2)) || CL_NILP(STACK(base, 2)))
		{
			LOAD_SYMBOL(SYMBOL(Slisp, 28), STACK(base, 11)); /* LIST */
		}
		else
		{
			if(TYPE_OF(STACK(base, 2)) >= T_VEC_LO && TYPE_OF(STACK(base, 2)) <= T_VEC_HI)
			{
				LOAD_SYMBOL(SYMBOL(Slisp, 47), STACK(base, 11)); /* VECTOR */
				COPY(STACK(base, 2), STACK(base, 12));
				array_element_type_internal(STACK(base, 12));
				to_element_type(STACK(base, 12));
				Flist(STACK(base, 11), 2);
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[38], STACK(base, 11)); /* Unexpected error */
				Ferror(STACK(base, 11), 1);
			}
		}
		COPY(STACK(base, 10), STACK(base, 12));
		Fmake_sequence(STACK(base, 11), 2);
		COPY(STACK(base, 10), STACK(base, 12));
		F1minus(STACK(base, 12));
		LOAD_FIXNUM(0, STACK(base, 13));
		M187_1:;
		COPY(STACK(base, 12), STACK(base, 14));
		Fminusp(STACK(base, 14));
		if(CL_TRUEP(STACK(base, 14)))
		{
			COPY(STACK(base, 11), STACK(base, 0));
			goto RETURN213;
		}
		COPY(STACK(base, 6), STACK(base, 14));
		COPY(STACK(base, 12), STACK(base, 15));
		Fle(STACK(base, 14), 2);
		if(CL_TRUEP(STACK(base, 14)))
		{
			COPY(STACK(base, 12), STACK(base, 14));
			COPY(STACK(base, 7), STACK(base, 15));
			Flt(STACK(base, 14), 2);
			if(CL_TRUEP(STACK(base, 14)))
			{
				COPY(STACK(base, 13), STACK(base, 14));
				COPY(STACK(base, 8), STACK(base, 15));
				Flt(STACK(base, 14), 2);
				if(CL_TRUEP(STACK(base, 14)))
				{
					COPY(STACK(base, 4), STACK(base, 14));
					COPY(STACK(base, 1), STACK(base, 15));
					COPY(STACK(base, 9), STACK(base, 16));
					COPY(STACK(base, 2), STACK(base, 17));
					COPY(STACK(base, 12), STACK(base, 18));
					Felt(STACK(base, 17));
					Ffuncall(STACK(base, 16), 2);
					mv_count = 1;
					Ffuncall(STACK(base, 14), 3);
					mv_count = 1;
					bool_result = CL_TRUEP(STACK(base, 14));
				}
				else
				{
					bool_result = FALSE;
				}
			}
			else
			{
				bool_result = FALSE;
			}
		}
		else
		{
			bool_result = FALSE;
		}
		if(bool_result)
		{
			COPY(STACK(base, 12), STACK(base, 14));
			COPY(STACK(base, 0), STACK(base, 15));
			COPY(STACK(base, 11), STACK(base, 16));
			COPY(STACK(base, 14), STACK(base, 17));
			Fset_elt(STACK(base, 15));
			COPY(STACK(base, 13), STACK(base, 14));
			F1plus(STACK(base, 14));
			COPY(STACK(base, 14), STACK(base, 13));
		}
		else
		{
			COPY(STACK(base, 12), STACK(base, 14));
			COPY(STACK(base, 2), STACK(base, 15));
			COPY(STACK(base, 12), STACK(base, 16));
			Felt(STACK(base, 15));
			COPY(STACK(base, 15), STACK(base, 16));
			COPY(STACK(base, 11), STACK(base, 17));
			COPY(STACK(base, 14), STACK(base, 18));
			Fset_elt(STACK(base, 16));
		}
		COPY(STACK(base, 12), STACK(base, 14));
		F1minus(STACK(base, 14));
		COPY(STACK(base, 14), STACK(base, 12));
		goto M187_1;
		RETURN213:;
	}
	else
	{
		COPY(STACK(base, 2), STACK(base, 11));
		if(CL_CONSP(STACK(base, 2)) || CL_NILP(STACK(base, 2)))
		{
			LOAD_SYMBOL(SYMBOL(Slisp, 28), STACK(base, 11)); /* LIST */
		}
		else
		{
			if(TYPE_OF(STACK(base, 2)) >= T_VEC_LO && TYPE_OF(STACK(base, 2)) <= T_VEC_HI)
			{
				LOAD_SYMBOL(SYMBOL(Slisp, 47), STACK(base, 11)); /* VECTOR */
				COPY(STACK(base, 2), STACK(base, 12));
				array_element_type_internal(STACK(base, 12));
				to_element_type(STACK(base, 12));
				Flist(STACK(base, 11), 2);
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[38], STACK(base, 11)); /* Unexpected error */
				Ferror(STACK(base, 11), 1);
			}
		}
		COPY(STACK(base, 10), STACK(base, 12));
		Fmake_sequence(STACK(base, 11), 2);
		LOAD_FIXNUM(0, STACK(base, 12));
		LOAD_FIXNUM(0, STACK(base, 13));
		M188_1:;
		COPY(STACK(base, 12), STACK(base, 14));
		COPY(STACK(base, 10), STACK(base, 15));
		Fge(STACK(base, 14), 2);
		if(CL_TRUEP(STACK(base, 14)))
		{
			COPY(STACK(base, 11), STACK(base, 0));
			goto RETURN214;
		}
		COPY(STACK(base, 6), STACK(base, 14));
		COPY(STACK(base, 12), STACK(base, 15));
		Fle(STACK(base, 14), 2);
		if(CL_TRUEP(STACK(base, 14)))
		{
			COPY(STACK(base, 12), STACK(base, 14));
			COPY(STACK(base, 7), STACK(base, 15));
			Flt(STACK(base, 14), 2);
			if(CL_TRUEP(STACK(base, 14)))
			{
				COPY(STACK(base, 13), STACK(base, 14));
				COPY(STACK(base, 8), STACK(base, 15));
				Flt(STACK(base, 14), 2);
				if(CL_TRUEP(STACK(base, 14)))
				{
					COPY(STACK(base, 4), STACK(base, 14));
					COPY(STACK(base, 1), STACK(base, 15));
					COPY(STACK(base, 9), STACK(base, 16));
					COPY(STACK(base, 2), STACK(base, 17));
					COPY(STACK(base, 12), STACK(base, 18));
					Felt(STACK(base, 17));
					Ffuncall(STACK(base, 16), 2);
					mv_count = 1;
					Ffuncall(STACK(base, 14), 3);
					mv_count = 1;
					bool_result = CL_TRUEP(STACK(base, 14));
				}
				else
				{
					bool_result = FALSE;
				}
			}
			else
			{
				bool_result = FALSE;
			}
		}
		else
		{
			bool_result = FALSE;
		}
		if(bool_result)
		{
			COPY(STACK(base, 12), STACK(base, 14));
			COPY(STACK(base, 0), STACK(base, 15));
			COPY(STACK(base, 11), STACK(base, 16));
			COPY(STACK(base, 14), STACK(base, 17));
			Fset_elt(STACK(base, 15));
			COPY(STACK(base, 13), STACK(base, 14));
			F1plus(STACK(base, 14));
			COPY(STACK(base, 14), STACK(base, 13));
		}
		else
		{
			COPY(STACK(base, 12), STACK(base, 14));
			COPY(STACK(base, 2), STACK(base, 15));
			COPY(STACK(base, 12), STACK(base, 16));
			Felt(STACK(base, 15));
			COPY(STACK(base, 15), STACK(base, 16));
			COPY(STACK(base, 11), STACK(base, 17));
			COPY(STACK(base, 14), STACK(base, 18));
			Fset_elt(STACK(base, 16));
		}
		COPY(STACK(base, 12), STACK(base, 14));
		F1plus(STACK(base, 14));
		COPY(STACK(base, 14), STACK(base, 12));
		goto M188_1;
		RETURN214:;
	}
}
