#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

CL_INIT Kformat2[] =
{
{ CL_FIXNUM, 31 }, /* 0 */
{ RT_CHAR_PTR, (long)"Not enough arguments for format" },
{ CL_FIXNUM, 41 }, /* 2 */
{ RT_CHAR_PTR, (long)"Syntax error at end of control-string: ~s" },
{ CL_FIXNUM, 41 }, /* 4 */
{ RT_CHAR_PTR, (long)"Syntax error at end of control-string: ~s" },
{ CL_FIXNUM, 27 }, /* 6 */
{ RT_CHAR_PTR, (long)"Too many at-signs supplied." },
{ CL_FIXNUM, 25 }, /* 8 */
{ RT_CHAR_PTR, (long)"Too many colons supplied." },
{ CL_FIXNUM, 41 }, /* 10 */
{ RT_CHAR_PTR, (long)"Syntax error at end of control-string: ~s" },
{ CL_FIXNUM, 3 }, /* 12 */
{ RT_CHAR_PTR, (long)"ies" },
{ CL_FIXNUM, 23 }, /* 14 */
{ RT_CHAR_PTR, (long)"illegal directive ~~:@p" },
{ CL_FIXNUM, 23 }, /* 16 */
{ RT_CHAR_PTR, (long)"illegal directive ~~:@*" },
{ CL_FIXNUM, 40 }, /* 18 */
{ RT_CHAR_PTR, (long)"~~~a:* will skip to nonexistant argument" },
{ CL_FIXNUM, 32 }, /* 20 */
{ RT_CHAR_PTR, (long)"unexpected ~~} in control-string" },
{ CL_FIXNUM, 84 }, /* 22 */
{ RT_CHAR_PTR, (long)"illegal / unimplemented directive (~A) in ~\n                          control-string" },
{ CL_FIXNUM, 32 }, /* 24 */
{ RT_CHAR_PTR, (long)"unexpected end of control-string" },
};

static void Z114_goto(CL_FORM *base, CL_FORM *display[]);
static void Z115_get_arg(CL_FORM *base, CL_FORM *display[]);
static void Z116_get_param(CL_FORM *base, CL_FORM *display[]);
static void Z117_get_at_sign_or_colon(CL_FORM *base, CL_FORM *display[]);
static void Z118_get_directive(CL_FORM *base, CL_FORM *display[]);
static void Z119_skip(CL_FORM *base, CL_FORM *display[]);
static void Z120_insert_space(CL_FORM *base, CL_FORM *display[]);

void format2(CL_FORM *base, int nargs)
{
	CL_FORM *display[1];
	switch(nargs)
	{
		case 3:
		LOAD_NIL(STACK(base, 3));
		case 4:
		LOAD_FIXNUM(0, STACK(base, 4));
		case 5:
		break;
		default:
		Labort(TOO_MANY_ARGS);
	}
	COPY(STACK(base, 2), STACK(base, 5));
	LOAD_FIXNUM(0, STACK(base, 6));
	LOAD_NIL(STACK(base, 7));
	if(CL_CONSP(STACK(base, 1)) || CL_NILP(STACK(base, 1)))
	{
		COPY(STACK(base, 1), STACK(base, 8));
		raw_list_length(STACK(base, 8));
	}
	else
	{
		if(TYPE_OF(STACK(base, 1)) >= T_VEC_LO && TYPE_OF(STACK(base, 1)) <= T_VEC_HI)
		{
			LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 1))), STACK(base, 8));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 8)); /* ~a is not a sequence */
			COPY(STACK(base, 1), STACK(base, 9));
			Ferror(STACK(base, 8), 2);
		}
	}
	LOAD_NIL(STACK(base, 9));
	LOAD_NIL(STACK(base, 10));
	LOAD_NIL(STACK(base, 11));
	LOAD_NIL(STACK(base, 12));
	M128_1:;
	COPY(STACK(base, 4), STACK(base, 13));
	COPY(STACK(base, 8), STACK(base, 14));
	Fge(STACK(base, 13), 2);
	if(CL_TRUEP(STACK(base, 13)))
	{
		LOAD_NIL(STACK(base, 9));
	}
	else
	{
		COPY(STACK(base, 1), STACK(base, 13));
		COPY(STACK(base, 4), STACK(base, 14));
		Fchar(STACK(base, 13));
		COPY(STACK(base, 4), STACK(base, 14));
		F1plus(STACK(base, 14));
		COPY(STACK(base, 14), STACK(base, 4));
		COPY(STACK(base, 13), STACK(base, 9));
	}
	if(CL_TRUEP(STACK(base, 9)))
	{
	}
	else
	{
		goto RETURN150;
	}
	if(GET_CHAR(STACK(base, 9)) == '~' && CL_CHARP(STACK(base, 9)))
	{
		display[0] = STACK(base, 0);
		Z116_get_param(STACK(base, 13), display);
		display[0] = STACK(base, 0);
		Z117_get_at_sign_or_colon(STACK(base, 13), display);
		display[0] = STACK(base, 0);
		Z118_get_directive(STACK(base, 13), display);
		COPY(STACK(base, 13), STACK(base, 9));
		Fchar_upcase(STACK(base, 13));
		if(GET_CHAR(STACK(base, 13)) == 'A' && CL_CHARP(STACK(base, 13)))
		{
			COPY(STACK(base, 0), STACK(base, 14));
			stream_column(STACK(base, 14));
			Ffuncall(STACK(base, 14), 1);
			mv_count = 1;
			display[0] = STACK(base, 0);
			Z115_get_arg(STACK(base, 15), display);
			COPY(STACK(base, 0), STACK(base, 16));
			Fprinc(STACK(base, 15), 2);
			COPY(STACK(base, 10), STACK(base, 15));
			COPY(STACK(base, 14), STACK(base, 16));
			display[0] = STACK(base, 0);
			Z120_insert_space(STACK(base, 15), display);
		}
		else
		{
			if(GET_CHAR(STACK(base, 13)) == 'S' && CL_CHARP(STACK(base, 13)))
			{
				COPY(STACK(base, 0), STACK(base, 14));
				stream_column(STACK(base, 14));
				Ffuncall(STACK(base, 14), 1);
				mv_count = 1;
				display[0] = STACK(base, 0);
				Z115_get_arg(STACK(base, 15), display);
				COPY(STACK(base, 0), STACK(base, 16));
				Fprin1(STACK(base, 15), 2);
				COPY(STACK(base, 10), STACK(base, 15));
				COPY(STACK(base, 14), STACK(base, 16));
				display[0] = STACK(base, 0);
				Z120_insert_space(STACK(base, 15), display);
			}
			else
			{
				if(GET_CHAR(STACK(base, 13)) == 'D' && CL_CHARP(STACK(base, 13)))
				{
					COPY(STACK(base, 0), STACK(base, 14));
					stream_column(STACK(base, 14));
					Ffuncall(STACK(base, 14), 1);
					mv_count = 1;
					display[0] = STACK(base, 0);
					Z115_get_arg(STACK(base, 15), display);
					LOAD_NIL(STACK(base, 16));
					BIND_SPECIAL(SYMBOL(Slisp, 490), STACK(base, 16)); /* *PRINT-RADIX* */
					LOAD_FIXNUM(10, STACK(base, 17));
					BIND_SPECIAL(SYMBOL(Slisp, 482), STACK(base, 17)); /* *PRINT-BASE* */
					if(CL_FIXNUMP(STACK(base, 15)))
					{
						if(CL_TRUEP(STACK(base, 11)))
						{
							COPY(STACK(base, 15), STACK(base, 18));
							Fplusp(STACK(base, 18));
							bool_result = CL_TRUEP(STACK(base, 18));
						}
						else
						{
							bool_result = FALSE;
						}
					}
					else
					{
						bool_result = FALSE;
					}
					if(bool_result)
					{
						LOAD_CHAR('+', STACK(base, 18));
						COPY(STACK(base, 0), STACK(base, 19));
						Fwrite_char(STACK(base, 18), 2);
						mv_count = 1;
					}
					COPY(STACK(base, 15), STACK(base, 18));
					COPY(STACK(base, 0), STACK(base, 19));
					Fprinc(STACK(base, 18), 2);
					COPY(STACK(base, 10), STACK(base, 18));
					COPY(STACK(base, 14), STACK(base, 19));
					display[0] = STACK(base, 0);
					Z120_insert_space(STACK(base, 18), display);
					RESTORE_SPECIAL;
					RESTORE_SPECIAL;
				}
				else
				{
					if(GET_CHAR(STACK(base, 13)) == 'B' && CL_CHARP(STACK(base, 13)))
					{
						COPY(STACK(base, 0), STACK(base, 14));
						stream_column(STACK(base, 14));
						Ffuncall(STACK(base, 14), 1);
						mv_count = 1;
						LOAD_NIL(STACK(base, 15));
						BIND_SPECIAL(SYMBOL(Slisp, 490), STACK(base, 15)); /* *PRINT-RADIX* */
						LOAD_FIXNUM(2, STACK(base, 16));
						BIND_SPECIAL(SYMBOL(Slisp, 482), STACK(base, 16)); /* *PRINT-BASE* */
						display[0] = STACK(base, 0);
						Z115_get_arg(STACK(base, 17), display);
						COPY(STACK(base, 0), STACK(base, 18));
						Fprinc(STACK(base, 17), 2);
						COPY(STACK(base, 10), STACK(base, 17));
						COPY(STACK(base, 14), STACK(base, 18));
						display[0] = STACK(base, 0);
						Z120_insert_space(STACK(base, 17), display);
						RESTORE_SPECIAL;
						RESTORE_SPECIAL;
					}
					else
					{
						if(GET_CHAR(STACK(base, 13)) == 'O' && CL_CHARP(STACK(base, 13)))
						{
							COPY(STACK(base, 0), STACK(base, 14));
							stream_column(STACK(base, 14));
							Ffuncall(STACK(base, 14), 1);
							mv_count = 1;
							LOAD_NIL(STACK(base, 15));
							BIND_SPECIAL(SYMBOL(Slisp, 490), STACK(base, 15)); /* *PRINT-RADIX* */
							LOAD_FIXNUM(8, STACK(base, 16));
							BIND_SPECIAL(SYMBOL(Slisp, 482), STACK(base, 16)); /* *PRINT-BASE* */
							display[0] = STACK(base, 0);
							Z115_get_arg(STACK(base, 17), display);
							COPY(STACK(base, 0), STACK(base, 18));
							Fprinc(STACK(base, 17), 2);
							COPY(STACK(base, 10), STACK(base, 17));
							COPY(STACK(base, 14), STACK(base, 18));
							display[0] = STACK(base, 0);
							Z120_insert_space(STACK(base, 17), display);
							RESTORE_SPECIAL;
							RESTORE_SPECIAL;
						}
						else
						{
							if(GET_CHAR(STACK(base, 13)) == 'P' && CL_CHARP(STACK(base, 13)))
							{
								if(CL_TRUEP(STACK(base, 12)))
								{
									COPY(STACK(base, 7), STACK(base, 14));
								}
								else
								{
									display[0] = STACK(base, 0);
									Z115_get_arg(STACK(base, 14), display);
								}
								if(GET_FIXNUM(STACK(base, 14)) == 1 && CL_FIXNUMP(STACK(base, 14)))
								{
									if(CL_TRUEP(STACK(base, 11)))
									{
										LOAD_CHAR('y', STACK(base, 15));
										COPY(STACK(base, 0), STACK(base, 16));
										Fwrite_char(STACK(base, 15), 2);
										mv_count = 1;
									}
								}
								else
								{
									if(CL_TRUEP(STACK(base, 11)))
									{
										LOAD_SMSTR((CL_FORM *)&Kformat2[12], STACK(base, 15)); /* ies */
										COPY(STACK(base, 0), STACK(base, 16));
										Fprinc(STACK(base, 15), 2);
									}
									else
									{
										LOAD_CHAR('s', STACK(base, 15));
										COPY(STACK(base, 0), STACK(base, 16));
										Fwrite_char(STACK(base, 15), 2);
										mv_count = 1;
									}
								}
							}
							else
							{
								if(GET_CHAR(STACK(base, 13)) == 'F' && CL_CHARP(STACK(base, 13)))
								{
									COPY(STACK(base, 0), STACK(base, 14));
									stream_column(STACK(base, 14));
									Ffuncall(STACK(base, 14), 1);
									mv_count = 1;
									display[0] = STACK(base, 0);
									Z115_get_arg(STACK(base, 15), display);
									COPY(STACK(base, 0), STACK(base, 16));
									Fprinc(STACK(base, 15), 2);
									COPY(STACK(base, 10), STACK(base, 15));
									COPY(STACK(base, 14), STACK(base, 16));
									display[0] = STACK(base, 0);
									Z120_insert_space(STACK(base, 15), display);
								}
								else
								{
									if(GET_CHAR(STACK(base, 13)) == '%' && CL_CHARP(STACK(base, 13)))
									{
										if(CL_FIXNUMP(STACK(base, 10)) || CL_FLOATP(STACK(base, 10)))
										{
											COPY(STACK(base, 10), STACK(base, 14));
											LOAD_FIXNUM(0, STACK(base, 15));
											M129_1:;
											COPY(STACK(base, 15), STACK(base, 16));
											COPY(STACK(base, 14), STACK(base, 17));
											Fge(STACK(base, 16), 2);
											if(CL_TRUEP(STACK(base, 16)))
											{
												goto RETURN151;
											}
											COPY(STACK(base, 0), STACK(base, 16));
											Fterpri(STACK(base, 16), 1);
											F1plus(STACK(base, 15));
											goto M129_1;
											RETURN151:;
										}
										else
										{
											COPY(STACK(base, 0), STACK(base, 14));
											Fterpri(STACK(base, 14), 1);
										}
									}
									else
									{
										if(GET_CHAR(STACK(base, 13)) == '&' && CL_CHARP(STACK(base, 13)))
										{
											if(CL_FIXNUMP(STACK(base, 10)) || CL_FLOATP(STACK(base, 10)))
											{
												COPY(STACK(base, 10), STACK(base, 14));
												Fzerop(STACK(base, 14));
												if(CL_TRUEP(STACK(base, 14)))
												{
												}
												else
												{
													COPY(STACK(base, 0), STACK(base, 14));
													Ffresh_line(STACK(base, 14), 1);
													mv_count = 1;
													COPY(STACK(base, 10), STACK(base, 14));
													F1minus(STACK(base, 14));
													LOAD_FIXNUM(0, STACK(base, 15));
													M130_1:;
													COPY(STACK(base, 15), STACK(base, 16));
													COPY(STACK(base, 14), STACK(base, 17));
													Fge(STACK(base, 16), 2);
													if(CL_TRUEP(STACK(base, 16)))
													{
														goto RETURN152;
													}
													COPY(STACK(base, 0), STACK(base, 16));
													Fterpri(STACK(base, 16), 1);
													F1plus(STACK(base, 15));
													goto M130_1;
													RETURN152:;
												}
											}
											else
											{
												COPY(STACK(base, 0), STACK(base, 14));
												Ffresh_line(STACK(base, 14), 1);
												mv_count = 1;
											}
										}
										else
										{
											if(GET_CHAR(STACK(base, 13)) == '|' && CL_CHARP(STACK(base, 13)))
											{
												if(CL_FIXNUMP(STACK(base, 10)) || CL_FLOATP(STACK(base, 10)))
												{
													COPY(STACK(base, 10), STACK(base, 14));
													LOAD_FIXNUM(0, STACK(base, 15));
													M131_1:;
													COPY(STACK(base, 15), STACK(base, 16));
													COPY(STACK(base, 14), STACK(base, 17));
													Fge(STACK(base, 16), 2);
													if(CL_TRUEP(STACK(base, 16)))
													{
														goto RETURN153;
													}
													LOAD_CHAR('\f', STACK(base, 16));
													COPY(STACK(base, 0), STACK(base, 17));
													Fwrite_char(STACK(base, 16), 2);
													mv_count = 1;
													F1plus(STACK(base, 15));
													goto M131_1;
													RETURN153:;
												}
												else
												{
													LOAD_CHAR('\f', STACK(base, 14));
													COPY(STACK(base, 0), STACK(base, 15));
													Fwrite_char(STACK(base, 14), 2);
													mv_count = 1;
												}
											}
											else
											{
												if(GET_CHAR(STACK(base, 13)) == '~' && CL_CHARP(STACK(base, 13)))
												{
													if(CL_FIXNUMP(STACK(base, 10)) || CL_FLOATP(STACK(base, 10)))
													{
														COPY(STACK(base, 10), STACK(base, 14));
														LOAD_FIXNUM(0, STACK(base, 15));
														M132_1:;
														COPY(STACK(base, 15), STACK(base, 16));
														COPY(STACK(base, 14), STACK(base, 17));
														Fge(STACK(base, 16), 2);
														if(CL_TRUEP(STACK(base, 16)))
														{
															goto RETURN154;
														}
														LOAD_CHAR('~', STACK(base, 16));
														COPY(STACK(base, 0), STACK(base, 17));
														Fwrite_char(STACK(base, 16), 2);
														mv_count = 1;
														F1plus(STACK(base, 15));
														goto M132_1;
														RETURN154:;
													}
													else
													{
														LOAD_CHAR('~', STACK(base, 14));
														COPY(STACK(base, 0), STACK(base, 15));
														Fwrite_char(STACK(base, 14), 2);
														mv_count = 1;
													}
												}
												else
												{
													if(GET_CHAR(STACK(base, 13)) == '\n' && CL_CHARP(STACK(base, 13)))
													{
														if(CL_TRUEP(STACK(base, 11)))
														{
															if(CL_TRUEP(STACK(base, 12)))
															{
																LOAD_SMSTR((CL_FORM *)&Kformat2[14], STACK(base, 14)); /* illegal directive ~~:@p */
																Ferror(STACK(base, 14), 1);
															}
															COPY(STACK(base, 0), STACK(base, 14));
															Fterpri(STACK(base, 14), 1);
														}
														if(CL_TRUEP(STACK(base, 12)))
														{
														}
														else
														{
															M133_1:;
															COPY(STACK(base, 4), STACK(base, 14));
															COPY(STACK(base, 8), STACK(base, 15));
															Fge(STACK(base, 14), 2);
															if(CL_TRUEP(STACK(base, 14)))
															{
																LOAD_NIL(STACK(base, 9));
															}
															else
															{
																COPY(STACK(base, 1), STACK(base, 14));
																COPY(STACK(base, 4), STACK(base, 15));
																Fchar(STACK(base, 14));
																COPY(STACK(base, 4), STACK(base, 15));
																F1plus(STACK(base, 15));
																COPY(STACK(base, 15), STACK(base, 4));
																COPY(STACK(base, 14), STACK(base, 9));
															}
															if(CL_TRUEP(STACK(base, 9)))
															{
															}
															else
															{
																goto RETURN155;
															}
															if(GET_CHAR(STACK(base, 9)) == ' ' && CL_CHARP(STACK(base, 9)))
															{
															}
															else
															{
																COPY(STACK(base, 4), STACK(base, 14));
																F1minus(STACK(base, 14));
																COPY(STACK(base, 14), STACK(base, 4));
																goto RETURN155;
															}
															goto M133_1;
															RETURN155:;
														}
													}
													else
													{
														if(GET_CHAR(STACK(base, 13)) == '*' && CL_CHARP(STACK(base, 13)))
														{
															if(CL_TRUEP(STACK(base, 11)))
															{
																if(CL_TRUEP(STACK(base, 12)))
																{
																	LOAD_SMSTR((CL_FORM *)&Kformat2[16], STACK(base, 14)); /* illegal directive ~~:@* */
																	Ferror(STACK(base, 14), 1);
																}
																if(CL_FIXNUMP(STACK(base, 10)) || CL_FLOATP(STACK(base, 10)))
																{
																}
																else
																{
																	LOAD_FIXNUM(0, STACK(base, 10));
																}
																COPY(STACK(base, 10), STACK(base, 14));
																display[0] = STACK(base, 0);
																Z114_goto(STACK(base, 14), display);
															}
															else
															{
																if(CL_TRUEP(STACK(base, 12)))
																{
																	if(CL_FIXNUMP(STACK(base, 10)) || CL_FLOATP(STACK(base, 10)))
																	{
																	}
																	else
																	{
																		LOAD_FIXNUM(1, STACK(base, 10));
																	}
																	COPY(STACK(base, 10), STACK(base, 14));
																	COPY(STACK(base, 6), STACK(base, 15));
																	Fgt(STACK(base, 14), 2);
																	if(CL_TRUEP(STACK(base, 14)))
																	{
																		LOAD_SMSTR((CL_FORM *)&Kformat2[18], STACK(base, 14)); /* ~~~a:* will skip to nonexistant argument */
																		COPY(STACK(base, 10), STACK(base, 15));
																		Ferror(STACK(base, 14), 2);
																	}
																	COPY(STACK(base, 6), STACK(base, 14));
																	COPY(STACK(base, 10), STACK(base, 15));
																	Fminus(STACK(base, 14), 2);
																	display[0] = STACK(base, 0);
																	Z114_goto(STACK(base, 14), display);
																}
																else
																{
																	if(CL_FIXNUMP(STACK(base, 10)) || CL_FLOATP(STACK(base, 10)))
																	{
																	}
																	else
																	{
																		LOAD_FIXNUM(1, STACK(base, 10));
																	}
																	COPY(STACK(base, 10), STACK(base, 14));
																	LOAD_FIXNUM(0, STACK(base, 15));
																	M134_1:;
																	COPY(STACK(base, 15), STACK(base, 16));
																	COPY(STACK(base, 14), STACK(base, 17));
																	Fge(STACK(base, 16), 2);
																	if(CL_TRUEP(STACK(base, 16)))
																	{
																		goto RETURN156;
																	}
																	display[0] = STACK(base, 0);
																	Z115_get_arg(STACK(base, 16), display);
																	F1plus(STACK(base, 15));
																	goto M134_1;
																	RETURN156:;
																}
															}
														}
														else
														{
															if(GET_CHAR(STACK(base, 13)) == '?' && CL_CHARP(STACK(base, 13)))
															{
																COPY(STACK(base, 0), STACK(base, 14));
																display[0] = STACK(base, 0);
																Z115_get_arg(STACK(base, 15), display);
																display[0] = STACK(base, 0);
																Z115_get_arg(STACK(base, 16), display);
																format2(STACK(base, 14), 3);
																mv_count = 1;
															}
															else
															{
																if(GET_CHAR(STACK(base, 13)) == '{' && CL_CHARP(STACK(base, 13)))
																{
																	display[0] = STACK(base, 0);
																	Z115_get_arg(STACK(base, 14), display);
																	LOAD_NIL(STACK(base, 15));
																	M135_1:;
																	if(CL_TRUEP(STACK(base, 14)))
																	{
																	}
																	else
																	{
																		goto RETURN157;
																	}
																	COPY(STACK(base, 0), STACK(base, 16));
																	COPY(STACK(base, 1), STACK(base, 17));
																	COPY(STACK(base, 14), STACK(base, 18));
																	LOAD_CHAR('}', STACK(base, 19));
																	COPY(STACK(base, 4), STACK(base, 20));
																	format2(STACK(base, 16), 5);
																	{
																		int i;
																		for(i = 0; i < mv_count-1; i++)
																		COPY(&mv_buf[i], STACK(base, i + 17));
																	}
																	{
																		int nargs;
																		nargs = mv_count;
																		mv_count = 1;
																		switch(nargs)
																		{
																			case 0:
																			LOAD_NIL(STACK(base, 16));
																			case 1:
																			LOAD_NIL(STACK(base, 17));
																			nargs = 2;
																		}
																		Flist(STACK(base, 18), nargs - 2);
																		COPY(STACK(base, 16), STACK(base, 14));
																		COPY(STACK(base, 17), STACK(base, 15));
																	}
																	goto M135_1;
																	RETURN157:;
																	if(CL_TRUEP(STACK(base, 15)))
																	{
																		COPY(STACK(base, 15), STACK(base, 4));
																	}
																	else
																	{
																		LOAD_CHAR('}', STACK(base, 16));
																		display[0] = STACK(base, 0);
																		Z119_skip(STACK(base, 16), display);
																	}
																}
																else
																{
																	if(GET_CHAR(STACK(base, 13)) == '}' && CL_CHARP(STACK(base, 13)))
																	{
																		if(GET_CHAR(STACK(base, 3)) == '}' && CL_CHARP(STACK(base, 3)))
																		{
																			COPY(STACK(base, 5), STACK(base, 14));
																			COPY(STACK(base, 4), STACK(base, 15));
																			COPY(STACK(base, 14), STACK(base, 0));
																			COPY(STACK(base, 15), &mv_buf[0]);
																			mv_count = 2;
																			goto RETURN149;
																		}
																		else
																		{
																			LOAD_SMSTR((CL_FORM *)&Kformat2[20], STACK(base, 14)); /* unexpected ~~} in control-string */
																			Ferror(STACK(base, 14), 1);
																		}
																	}
																	else
																	{
																		LOAD_SMSTR((CL_FORM *)&Kformat2[22], STACK(base, 14)); /* illegal / unimplemented directive (~A) in ~
                          control-string */
																		COPY(STACK(base, 9), STACK(base, 15));
																		Ferror(STACK(base, 14), 2);
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	else
	{
		COPY(STACK(base, 9), STACK(base, 13));
		COPY(STACK(base, 0), STACK(base, 14));
		Fwrite_char(STACK(base, 13), 2);
		mv_count = 1;
	}
	goto M128_1;
	RETURN150:;
	if(CL_TRUEP(STACK(base, 3)))
	{
		LOAD_SMSTR((CL_FORM *)&Kformat2[24], STACK(base, 0)); /* unexpected end of control-string */
		Ferror(STACK(base, 0), 1);
	}
	else
	{
		LOAD_NIL(STACK(base, 0));
	}
	RETURN149:;
}

static void Z114_goto(CL_FORM *base, CL_FORM *display[])
{
	if(GET_FIXNUM(STACK(base, 0)) == 0 && CL_FIXNUMP(STACK(base, 0)))
	{
		COPY(&display[0][2], &display[0][5]);
		LOAD_FIXNUM(0, &display[0][6]);
		LOAD_NIL(&display[0][7]);
		COPY(&display[0][7], STACK(base, 0));
	}
	else
	{
		COPY(&display[0][2], STACK(base, 1));
		COPY(STACK(base, 0), STACK(base, 2));
		F1minus(STACK(base, 2));
		Fnthcdr(STACK(base, 1));
		COPY(STACK(base, 1), &display[0][5]);
		COPY(STACK(base, 0), &display[0][6]);
		Z115_get_arg(STACK(base, 0), display);
	}
}

static void Z115_get_arg(CL_FORM *base, CL_FORM *display[])
{
	if(CL_TRUEP(&display[0][5]))
	{
	}
	else
	{
		LOAD_SMSTR((CL_FORM *)&Kformat2[0], STACK(base, 0)); /* Not enough arguments for format */
		Ferror(STACK(base, 0), 1);
	}
	COPY(&display[0][6], STACK(base, 0));
	F1plus(STACK(base, 0));
	COPY(STACK(base, 0), &display[0][6]);
	COPY(&display[0][5], STACK(base, 0));
	COPY(STACK(base, 0), STACK(base, 1));
	if(CL_TRUEP(STACK(base, 1)))
	{
		if(CL_CONSP(STACK(base, 1)))
		{
			COPY(GET_CAR(STACK(base, 1)), STACK(base, 0));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[62], STACK(base, 0)); /* ~a is not a list */
			Ferror(STACK(base, 0), 2);
		}
	}
	else
	{
		LOAD_NIL(STACK(base, 0));
	}
	COPY(&display[0][5], STACK(base, 1));
	COPY(STACK(base, 1), STACK(base, 2));
	if(CL_TRUEP(STACK(base, 2)))
	{
		if(CL_CONSP(STACK(base, 2)))
		{
			COPY(GET_CAR(STACK(base, 2)) + 1, &display[0][5]);
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[60], STACK(base, 3)); /* ~a is not a list */
			COPY(STACK(base, 2), STACK(base, 4));
			Ferror(STACK(base, 3), 2);
		}
	}
	else
	{
		LOAD_NIL(&display[0][5]);
	}
	COPY(STACK(base, 0), &display[0][7]);
}

static void Z116_get_param(CL_FORM *base, CL_FORM *display[])
{
	LOAD_NIL(STACK(base, 0));
	LOAD_NIL(STACK(base, 1));
	LOAD_NIL(STACK(base, 2));
	COPY(&display[0][4], STACK(base, 3));
	COPY(&display[0][8], STACK(base, 4));
	Fge(STACK(base, 3), 2);
	if(CL_TRUEP(STACK(base, 3)))
	{
		goto M136_1;
	}
	COPY(&display[0][1], STACK(base, 3));
	COPY(&display[0][4], STACK(base, 4));
	Fchar(STACK(base, 3));
	COPY(STACK(base, 3), STACK(base, 0));
	if(GET_CHAR(STACK(base, 0)) == '#' && CL_CHARP(STACK(base, 0)))
	{
		COPY(&display[0][5], STACK(base, 3));
		if(CL_CONSP(STACK(base, 3)) || CL_NILP(STACK(base, 3)))
		{
			COPY(STACK(base, 3), STACK(base, 4));
			raw_list_length(STACK(base, 4));
			COPY(STACK(base, 4), &display[0][10]);
		}
		else
		{
			if(TYPE_OF(STACK(base, 3)) >= T_VEC_LO && TYPE_OF(STACK(base, 3)) <= T_VEC_HI)
			{
				LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 3))), &display[0][10]);
			}
			else
			{
				LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 4)); /* ~a is not a sequence */
				COPY(STACK(base, 3), STACK(base, 5));
				Ferror(STACK(base, 4), 2);
			}
		}
		COPY(&display[0][4], STACK(base, 3));
		F1plus(STACK(base, 3));
		COPY(STACK(base, 3), &display[0][4]);
	}
	else
	{
		if(GET_CHAR(STACK(base, 0)) == 'V' && CL_CHARP(STACK(base, 0)))
		{
			LOAD_T(STACK(base, 3));
		}
		else
		{
			LOAD_NIL(STACK(base, 3));
		}
		if(CL_TRUEP(STACK(base, 3)))
		{
			bool_result = TRUE;
		}
		else
		{
			bool_result = GET_CHAR(STACK(base, 0)) == 'v' && CL_CHARP(STACK(base, 0));
		}
		if(bool_result)
		{
			Z115_get_arg(STACK(base, 3), display);
			COPY(STACK(base, 3), &display[0][10]);
			COPY(&display[0][4], STACK(base, 3));
			F1plus(STACK(base, 3));
			COPY(STACK(base, 3), &display[0][4]);
		}
		else
		{
			COPY(STACK(base, 0), STACK(base, 3));
			Fdigit_char_p(STACK(base, 3), 1);
			COPY(STACK(base, 3), STACK(base, 1));
			if(CL_TRUEP(STACK(base, 1)))
			{
				M137_1:;
				COPY(&display[0][4], STACK(base, 3));
				F1plus(STACK(base, 3));
				COPY(STACK(base, 3), &display[0][4]);
				COPY(&display[0][8], STACK(base, 4));
				Fge(STACK(base, 3), 2);
				if(CL_TRUEP(STACK(base, 3)))
				{
					goto M136_1;
				}
				COPY(&display[0][1], STACK(base, 3));
				COPY(&display[0][4], STACK(base, 4));
				Fchar(STACK(base, 3));
				COPY(STACK(base, 3), STACK(base, 0));
				COPY(STACK(base, 0), STACK(base, 2));
				Fdigit_char_p(STACK(base, 2), 1);
				if(CL_TRUEP(STACK(base, 2)))
				{
				}
				else
				{
					COPY(STACK(base, 1), &display[0][10]);
					goto RETURN159;
				}
				LOAD_FIXNUM(10, STACK(base, 3));
				COPY(STACK(base, 1), STACK(base, 4));
				Fmult(STACK(base, 3), 2);
				COPY(STACK(base, 2), STACK(base, 4));
				Fplus(STACK(base, 3), 2);
				COPY(STACK(base, 3), STACK(base, 1));
				goto M137_1;
				RETURN159:;
			}
			else
			{
				LOAD_NIL(&display[0][10]);
			}
		}
	}
	LOAD_NIL(STACK(base, 0));
	goto RETURN158;
	M136_1:;
	LOAD_SMSTR((CL_FORM *)&Kformat2[2], STACK(base, 3)); /* Syntax error at end of control-string: ~s */
	COPY(&display[0][1], STACK(base, 4));
	Ferror(STACK(base, 3), 2);
	LOAD_NIL(STACK(base, 0));
	RETURN158:;
}

static void Z117_get_at_sign_or_colon(CL_FORM *base, CL_FORM *display[])
{
	LOAD_NIL(&display[0][11]);
	LOAD_NIL(&display[0][12]);
	M138_1:;
	COPY(&display[0][4], STACK(base, 0));
	COPY(&display[0][8], STACK(base, 1));
	Fge(STACK(base, 0), 2);
	if(CL_TRUEP(STACK(base, 0)))
	{
		LOAD_SMSTR((CL_FORM *)&Kformat2[4], STACK(base, 0)); /* Syntax error at end of control-string: ~s */
		COPY(&display[0][1], STACK(base, 1));
		Ferror(STACK(base, 0), 2);
	}
	else
	{
		COPY(&display[0][1], STACK(base, 0));
		COPY(&display[0][4], STACK(base, 1));
		Fchar(STACK(base, 0));
		if(GET_CHAR(STACK(base, 0)) == '@' && CL_CHARP(STACK(base, 0)))
		{
			if(CL_TRUEP(&display[0][11]))
			{
				LOAD_SMSTR((CL_FORM *)&Kformat2[6], STACK(base, 0)); /* Too many at-signs supplied. */
				Ferror(STACK(base, 0), 1);
			}
			LOAD_SYMBOL(SYMBOL(Ssys, 1), &display[0][11]); /* T */
			COPY(&display[0][4], STACK(base, 0));
			F1plus(STACK(base, 0));
			COPY(STACK(base, 0), &display[0][4]);
		}
		else
		{
			COPY(&display[0][1], STACK(base, 0));
			COPY(&display[0][4], STACK(base, 1));
			Fchar(STACK(base, 0));
			if(GET_CHAR(STACK(base, 0)) == ':' && CL_CHARP(STACK(base, 0)))
			{
				if(CL_TRUEP(&display[0][12]))
				{
					LOAD_SMSTR((CL_FORM *)&Kformat2[8], STACK(base, 0)); /* Too many colons supplied. */
					Ferror(STACK(base, 0), 1);
				}
				LOAD_SYMBOL(SYMBOL(Ssys, 1), &display[0][12]); /* T */
				COPY(&display[0][4], STACK(base, 0));
				F1plus(STACK(base, 0));
				COPY(STACK(base, 0), &display[0][4]);
			}
			else
			{
				LOAD_NIL(STACK(base, 0));
				goto RETURN160;
			}
		}
	}
	goto M138_1;
	RETURN160:;
}

static void Z118_get_directive(CL_FORM *base, CL_FORM *display[])
{
	COPY(&display[0][4], STACK(base, 0));
	COPY(&display[0][8], STACK(base, 1));
	Fge(STACK(base, 0), 2);
	if(CL_TRUEP(STACK(base, 0)))
	{
		LOAD_SMSTR((CL_FORM *)&Kformat2[10], STACK(base, 0)); /* Syntax error at end of control-string: ~s */
		COPY(&display[0][1], STACK(base, 1));
		Ferror(STACK(base, 0), 2);
	}
	else
	{
		COPY(&display[0][1], STACK(base, 0));
		COPY(&display[0][4], STACK(base, 1));
		Fchar(STACK(base, 0));
		COPY(&display[0][4], STACK(base, 1));
		F1plus(STACK(base, 1));
		COPY(STACK(base, 1), &display[0][4]);
	}
}

static void Z119_skip(CL_FORM *base, CL_FORM *display[])
{
	M139_1:;
	COPY(&display[0][4], STACK(base, 1));
	COPY(&display[0][8], STACK(base, 2));
	Fge(STACK(base, 1), 2);
	if(CL_TRUEP(STACK(base, 1)))
	{
		LOAD_NIL(STACK(base, 1));
	}
	else
	{
		COPY(&display[0][1], STACK(base, 1));
		COPY(&display[0][4], STACK(base, 2));
		Fchar(STACK(base, 1));
		COPY(&display[0][4], STACK(base, 2));
		F1plus(STACK(base, 2));
		COPY(STACK(base, 2), &display[0][4]);
	}
	if(GET_CHAR(STACK(base, 1)) == '~' && CL_CHARP(STACK(base, 1)))
	{
		COPY(&display[0][4], STACK(base, 2));
		COPY(&display[0][8], STACK(base, 3));
		Fge(STACK(base, 2), 2);
		if(CL_TRUEP(STACK(base, 2)))
		{
			LOAD_NIL(STACK(base, 2));
		}
		else
		{
			COPY(&display[0][1], STACK(base, 2));
			COPY(&display[0][4], STACK(base, 3));
			Fchar(STACK(base, 2));
			COPY(&display[0][4], STACK(base, 3));
			F1plus(STACK(base, 3));
			COPY(STACK(base, 3), &display[0][4]);
		}
		if(TYPE_OF(STACK(base, 2)) == TYPE_OF(STACK(base, 0)) && (GET_FORM(STACK(base, 2)) == GET_FORM(STACK(base, 0)) || CL_FLOATP(STACK(base, 2)) && GET_FLOAT(STACK(base, 2)) == GET_FLOAT(STACK(base, 0))))
		{
			LOAD_NIL(STACK(base, 0));
			goto RETURN161;
		}
	}
	goto M139_1;
	RETURN161:;
}

static void Z120_insert_space(CL_FORM *base, CL_FORM *display[])
{
	if(CL_FIXNUMP(STACK(base, 0)) || CL_FLOATP(STACK(base, 0)))
	{
		COPY(&display[0][0], STACK(base, 2));
		stream_column(STACK(base, 2));
		Ffuncall(STACK(base, 2), 1);
		mv_count = 1;
		COPY(STACK(base, 1), STACK(base, 3));
		Fminus(STACK(base, 2), 2);
		COPY(STACK(base, 2), STACK(base, 1));
		M140_1:;
		COPY(STACK(base, 1), STACK(base, 2));
		COPY(STACK(base, 0), STACK(base, 3));
		Fge(STACK(base, 2), 2);
		if(CL_TRUEP(STACK(base, 2)))
		{
			LOAD_NIL(STACK(base, 0));
			goto RETURN162;
		}
		LOAD_CHAR(' ', STACK(base, 2));
		COPY(&display[0][0], STACK(base, 3));
		Fwrite_char(STACK(base, 2), 2);
		mv_count = 1;
		COPY(STACK(base, 1), STACK(base, 2));
		F1plus(STACK(base, 2));
		COPY(STACK(base, 2), STACK(base, 1));
		goto M140_1;
		RETURN162:;
	}
	else
	{
		LOAD_NIL(STACK(base, 0));
	}
}
