#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

CL_INIT KFmake_pathname[] =
{
{ CL_FIXNUM, 44 }, /* 0 */
{ RT_CHAR_PTR, (long)"etypecase: the value ~a is not a legal value" },
};

void Fmake_pathname(CL_FORM *base, int nargs)
{
	BOOL supl_flags[8];
	static CL_FORM * keylist[] =
	{
		SYMBOL(Slisp, 186), /* HOST */
		SYMBOL(Slisp, 187), /* DEVICE */
		SYMBOL(Slisp, 188), /* DIRECTORY */
		SYMBOL(Slisp, 189), /* NAME */
		SYMBOL(Slisp, 78), /* TYPE */
		SYMBOL(Slisp, 190), /* VERSION */
		SYMBOL(Slisp, 210), /* DEFAULTS */
		SYMBOL(Slisp, 212), /* CASE */
	};
	keysort(STACK(base, 0), nargs - 0, 8, keylist, supl_flags, FALSE);
	if(NOT(supl_flags[0]))
	{
		LOAD_NIL(STACK(base, 0));
		LOAD_NIL(STACK(base, 8));
	}
	else
	{
		LOAD_T(STACK(base, 8));
	}
	if(NOT(supl_flags[1]))
	{
		LOAD_NIL(STACK(base, 1));
		LOAD_NIL(STACK(base, 9));
	}
	else
	{
		LOAD_T(STACK(base, 9));
	}
	if(NOT(supl_flags[2]))
	{
		LOAD_NIL(STACK(base, 2));
		LOAD_NIL(STACK(base, 10));
	}
	else
	{
		LOAD_T(STACK(base, 10));
	}
	if(NOT(supl_flags[3]))
	{
		LOAD_NIL(STACK(base, 3));
		LOAD_NIL(STACK(base, 11));
	}
	else
	{
		LOAD_T(STACK(base, 11));
	}
	if(NOT(supl_flags[4]))
	{
		LOAD_NIL(STACK(base, 4));
		LOAD_NIL(STACK(base, 12));
	}
	else
	{
		LOAD_T(STACK(base, 12));
	}
	if(NOT(supl_flags[5]))
	{
		LOAD_NIL(STACK(base, 5));
		LOAD_NIL(STACK(base, 13));
	}
	else
	{
		LOAD_T(STACK(base, 13));
	}
	if(NOT(supl_flags[6]))
	{
		LOAD_NIL(STACK(base, 6));
	}
	if(NOT(supl_flags[7]))
	{
		LOAD_SYMBOL(SYMBOL(Slisp, 211), STACK(base, 7)); /* LOCAL */
	}
	if(CL_TRUEP(STACK(base, 6)))
	{
		COPY(STACK(base, 6), STACK(base, 14));
		COPY(STACK(base, 14), STACK(base, 15));
		LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 16)); /* PATHNAME */
		struct_typep(STACK(base, 15));
		if(CL_TRUEP(STACK(base, 15)))
		{
		}
		else
		{
			if(TYPE_OF(STACK(base, 14)) >= T_ARR_LO && TYPE_OF(STACK(base, 14)) <= T_ARR_HI)
			{
				COPY(STACK(base, 14), STACK(base, 15));
				LOAD_SYMBOL(SYMBOL(Slisp, 43), STACK(base, 16)); /* STANDARD-CHAR */
				LOAD_SYMBOL(SYMBOL(Slisp, 48), STACK(base, 17)); /* * */
				check_array_internal(STACK(base, 15));
				bool_result = CL_TRUEP(STACK(base, 15));
			}
			else
			{
				bool_result = FALSE;
			}
			if(bool_result)
			{
				Fparse_namestring(STACK(base, 14), 1);
				mv_count = 1;
			}
			else
			{
				COPY(STACK(base, 14), STACK(base, 15));
				LOAD_SYMBOL(SYMBOL(Slisp, 63), STACK(base, 16)); /* STREAM */
				struct_typep(STACK(base, 15));
				if(CL_TRUEP(STACK(base, 15)))
				{
					file_name(STACK(base, 14), 1);
					Fparse_namestring(STACK(base, 14), 1);
					mv_count = 1;
				}
				else
				{
					LOAD_SMSTR((CL_FORM *)&KFmake_pathname[0], STACK(base, 15)); /* etypecase: the value ~a is not a legal value */
					COPY(STACK(base, 14), STACK(base, 16));
					Ferror(STACK(base, 15), 2);
				}
			}
		}
	}
	else
	{
		LOAD_NIL(STACK(base, 14));
	}
	if(CL_TRUEP(STACK(base, 14)))
	{
		COPY(STACK(base, 14), STACK(base, 15));
		LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 16)); /* PATHNAME */
		COPY(STACK(base, 14), STACK(base, 17));
		LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 18)); /* PATHNAME */
		struct_typep(STACK(base, 17));
		if(CL_TRUEP(STACK(base, 17)))
		{
		}
		else
		{
			COPY(SYMVAL(Slisp, 409), STACK(base, 17)); /* NO_STRUCT */
			COPY(STACK(base, 14), STACK(base, 18));
			LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 19)); /* PATHNAME */
			Ferror(STACK(base, 17), 3);
		}
		COPY(STACK(base, 14), STACK(base, 15));
		LOAD_FIXNUM(0, STACK(base, 16));
		struct_ref_internal(STACK(base, 15));
	}
	else
	{
		COPY(SYMVAL(Slisp, 167), STACK(base, 15)); /* *DEFAULT-PATHNAME-DEFAULTS* */
		Fpathname_host(STACK(base, 15), 1);
	}
	if(CL_TRUEP(STACK(base, 8)))
	{
		COPY(STACK(base, 0), STACK(base, 16));
	}
	else
	{
		COPY(STACK(base, 15), STACK(base, 16));
	}
	if(GET_SYMBOL(STACK(base, 7)) == SYMBOL(Slisp, 213) && CL_SYMBOLP(STACK(base, 7))) /* COMMON */
	{
		COPY(STACK(base, 16), STACK(base, 17));
		LOAD_SYMBOL(SYMBOL(Slisp, 198), STACK(base, 18)); /* HOST */
		COPY(STACK(base, 16), STACK(base, 19));
		LOAD_SYMBOL(SYMBOL(Slisp, 198), STACK(base, 20)); /* HOST */
		struct_typep(STACK(base, 19));
		if(CL_TRUEP(STACK(base, 19)))
		{
		}
		else
		{
			COPY(SYMVAL(Slisp, 409), STACK(base, 19)); /* NO_STRUCT */
			COPY(STACK(base, 16), STACK(base, 20));
			LOAD_SYMBOL(SYMBOL(Slisp, 198), STACK(base, 21)); /* HOST */
			Ferror(STACK(base, 19), 3);
		}
		COPY(STACK(base, 16), STACK(base, 17));
		LOAD_FIXNUM(6, STACK(base, 18));
		struct_ref_internal(STACK(base, 17));
		if(GET_SYMBOL(STACK(base, 17)) == SYMBOL(Slisp, 214) && CL_SYMBOLP(STACK(base, 17))) /* LOWER */
		{
			LOAD_T(STACK(base, 17));
		}
		else
		{
			LOAD_NIL(STACK(base, 17));
		}
	}
	else
	{
		LOAD_NIL(STACK(base, 17));
	}
	COPY(STACK(base, 16), STACK(base, 18));
	LOAD_SYMBOL(SYMBOL(Slisp, 198), STACK(base, 19)); /* HOST */
	COPY(STACK(base, 16), STACK(base, 20));
	LOAD_SYMBOL(SYMBOL(Slisp, 198), STACK(base, 21)); /* HOST */
	struct_typep(STACK(base, 20));
	if(CL_TRUEP(STACK(base, 20)))
	{
	}
	else
	{
		COPY(SYMVAL(Slisp, 409), STACK(base, 20)); /* NO_STRUCT */
		COPY(STACK(base, 16), STACK(base, 21));
		LOAD_SYMBOL(SYMBOL(Slisp, 198), STACK(base, 22)); /* HOST */
		Ferror(STACK(base, 20), 3);
	}
	COPY(STACK(base, 16), STACK(base, 18));
	LOAD_FIXNUM(6, STACK(base, 19));
	struct_ref_internal(STACK(base, 18));
	COPY(STACK(base, 15), STACK(base, 19));
	LOAD_SYMBOL(SYMBOL(Slisp, 198), STACK(base, 20)); /* HOST */
	COPY(STACK(base, 15), STACK(base, 21));
	LOAD_SYMBOL(SYMBOL(Slisp, 198), STACK(base, 22)); /* HOST */
	struct_typep(STACK(base, 21));
	if(CL_TRUEP(STACK(base, 21)))
	{
	}
	else
	{
		COPY(SYMVAL(Slisp, 409), STACK(base, 21)); /* NO_STRUCT */
		COPY(STACK(base, 15), STACK(base, 22));
		LOAD_SYMBOL(SYMBOL(Slisp, 198), STACK(base, 23)); /* HOST */
		Ferror(STACK(base, 21), 3);
	}
	COPY(STACK(base, 15), STACK(base, 19));
	LOAD_FIXNUM(6, STACK(base, 20));
	struct_ref_internal(STACK(base, 19));
	if(NOT(GET_FORM(STACK(base, 18)) == GET_FORM(STACK(base, 19)) && TYPE_OF(STACK(base, 18)) == TYPE_OF(STACK(base, 19))))
	{
		LOAD_T(STACK(base, 18));
	}
	else
	{
		LOAD_NIL(STACK(base, 18));
	}
	LOAD_SYMBOL(SYMBOL(Slisp, 186), STACK(base, 19)); /* HOST */
	COPY(STACK(base, 16), STACK(base, 20));
	LOAD_SYMBOL(SYMBOL(Slisp, 187), STACK(base, 21)); /* DEVICE */
	if(CL_TRUEP(STACK(base, 9)))
	{
		COPY(STACK(base, 1), STACK(base, 22));
	}
	else
	{
		if(CL_TRUEP(STACK(base, 14)))
		{
			COPY(STACK(base, 14), STACK(base, 22));
			LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 23)); /* PATHNAME */
			COPY(STACK(base, 14), STACK(base, 24));
			LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 25)); /* PATHNAME */
			struct_typep(STACK(base, 24));
			if(CL_TRUEP(STACK(base, 24)))
			{
			}
			else
			{
				COPY(SYMVAL(Slisp, 409), STACK(base, 24)); /* NO_STRUCT */
				COPY(STACK(base, 14), STACK(base, 25));
				LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 26)); /* PATHNAME */
				Ferror(STACK(base, 24), 3);
			}
			COPY(STACK(base, 14), STACK(base, 22));
			LOAD_FIXNUM(1, STACK(base, 23));
			struct_ref_internal(STACK(base, 22));
		}
		else
		{
			LOAD_NIL(STACK(base, 22));
		}
	}
	LOAD_SYMBOL(SYMBOL(Slisp, 188), STACK(base, 23)); /* DIRECTORY */
	COPY(STACK(base, 2), STACK(base, 24));
	COPY(STACK(base, 17), STACK(base, 25));
	import_directory(STACK(base, 24));
	if(CL_TRUEP(STACK(base, 14)))
	{
		bool_result = NOT(CL_TRUEP(STACK(base, 10)));
	}
	else
	{
		bool_result = FALSE;
	}
	if(bool_result)
	{
		COPY(STACK(base, 24), STACK(base, 25));
		COPY(STACK(base, 14), STACK(base, 26));
		LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 27)); /* PATHNAME */
		COPY(STACK(base, 14), STACK(base, 28));
		LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 29)); /* PATHNAME */
		struct_typep(STACK(base, 28));
		if(CL_TRUEP(STACK(base, 28)))
		{
		}
		else
		{
			COPY(SYMVAL(Slisp, 409), STACK(base, 28)); /* NO_STRUCT */
			COPY(STACK(base, 14), STACK(base, 29));
			LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 30)); /* PATHNAME */
			Ferror(STACK(base, 28), 3);
		}
		COPY(STACK(base, 14), STACK(base, 26));
		LOAD_FIXNUM(2, STACK(base, 27));
		struct_ref_internal(STACK(base, 26));
		COPY(STACK(base, 18), STACK(base, 27));
		merge_directories(STACK(base, 25));
		COPY(STACK(base, 25), STACK(base, 24));
	}
	else
	{
	}
	LOAD_SYMBOL(SYMBOL(Slisp, 189), STACK(base, 25)); /* NAME */
	if(GET_SYMBOL(STACK(base, 3)) == SYMBOL(Slisp, 206) && CL_SYMBOLP(STACK(base, 3))) /* WILD */
	{
		LOAD_SYMBOL(SYMBOL(Slisp, 207), STACK(base, 26)); /* MULTI-CHAR-WILD */
		Flist(STACK(base, 26), 1);
		make_pattern(STACK(base, 26), 1);
	}
	else
	{
		if(CL_SMSTRP(STACK(base, 3)))
		{
			LOAD_T(STACK(base, 26));
		}
		else
		{
			LOAD_NIL(STACK(base, 26));
		}
		if(CL_TRUEP(STACK(base, 26)))
		{
			bool_result = TRUE;
		}
		else
		{
			COPY(STACK(base, 3), STACK(base, 27));
			LOAD_SYMBOL(SYMBOL(Slisp, 185), STACK(base, 28)); /* PATTERN */
			struct_typep(STACK(base, 27));
			bool_result = CL_TRUEP(STACK(base, 27));
		}
		if(bool_result)
		{
			COPY(STACK(base, 3), STACK(base, 26));
			COPY(STACK(base, 17), STACK(base, 27));
			maybe_diddle_case(STACK(base, 26));
			mv_count = 1;
		}
		else
		{
			if(CL_SMSTRP(STACK(base, 3)) || CL_STRINGP(STACK(base, 3)))
			{
				COPY(STACK(base, 3), STACK(base, 26));
				LOAD_SYMBOL(SYMBOL(Slisp, 40), STACK(base, 27)); /* SIMPLE-STRING */
				Fcoerce(STACK(base, 26));
				COPY(STACK(base, 17), STACK(base, 27));
				maybe_diddle_case(STACK(base, 26));
				mv_count = 1;
			}
			else
			{
				if(CL_TRUEP(STACK(base, 11)))
				{
					COPY(STACK(base, 3), STACK(base, 26));
					COPY(STACK(base, 17), STACK(base, 27));
					maybe_diddle_case(STACK(base, 26));
					mv_count = 1;
				}
				else
				{
					if(CL_TRUEP(STACK(base, 14)))
					{
						COPY(STACK(base, 14), STACK(base, 26));
						LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 27)); /* PATHNAME */
						COPY(STACK(base, 14), STACK(base, 28));
						LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 29)); /* PATHNAME */
						struct_typep(STACK(base, 28));
						if(CL_TRUEP(STACK(base, 28)))
						{
						}
						else
						{
							COPY(SYMVAL(Slisp, 409), STACK(base, 28)); /* NO_STRUCT */
							COPY(STACK(base, 14), STACK(base, 29));
							LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 30)); /* PATHNAME */
							Ferror(STACK(base, 28), 3);
						}
						COPY(STACK(base, 14), STACK(base, 26));
						LOAD_FIXNUM(3, STACK(base, 27));
						struct_ref_internal(STACK(base, 26));
						COPY(STACK(base, 18), STACK(base, 27));
						maybe_diddle_case(STACK(base, 26));
						mv_count = 1;
					}
					else
					{
						LOAD_NIL(STACK(base, 26));
					}
				}
			}
		}
	}
	LOAD_SYMBOL(SYMBOL(Slisp, 78), STACK(base, 27)); /* TYPE */
	if(GET_SYMBOL(STACK(base, 4)) == SYMBOL(Slisp, 206) && CL_SYMBOLP(STACK(base, 4))) /* WILD */
	{
		LOAD_SYMBOL(SYMBOL(Slisp, 207), STACK(base, 28)); /* MULTI-CHAR-WILD */
		Flist(STACK(base, 28), 1);
		make_pattern(STACK(base, 28), 1);
	}
	else
	{
		if(CL_SMSTRP(STACK(base, 4)))
		{
			LOAD_T(STACK(base, 28));
		}
		else
		{
			LOAD_NIL(STACK(base, 28));
		}
		if(CL_TRUEP(STACK(base, 28)))
		{
			bool_result = TRUE;
		}
		else
		{
			COPY(STACK(base, 4), STACK(base, 29));
			LOAD_SYMBOL(SYMBOL(Slisp, 185), STACK(base, 30)); /* PATTERN */
			struct_typep(STACK(base, 29));
			bool_result = CL_TRUEP(STACK(base, 29));
		}
		if(bool_result)
		{
			COPY(STACK(base, 4), STACK(base, 28));
			COPY(STACK(base, 17), STACK(base, 29));
			maybe_diddle_case(STACK(base, 28));
			mv_count = 1;
		}
		else
		{
			if(CL_SMSTRP(STACK(base, 4)) || CL_STRINGP(STACK(base, 4)))
			{
				COPY(STACK(base, 4), STACK(base, 28));
				LOAD_SYMBOL(SYMBOL(Slisp, 40), STACK(base, 29)); /* SIMPLE-STRING */
				Fcoerce(STACK(base, 28));
				COPY(STACK(base, 17), STACK(base, 29));
				maybe_diddle_case(STACK(base, 28));
				mv_count = 1;
			}
			else
			{
				if(CL_TRUEP(STACK(base, 12)))
				{
					COPY(STACK(base, 4), STACK(base, 28));
					COPY(STACK(base, 17), STACK(base, 29));
					maybe_diddle_case(STACK(base, 28));
					mv_count = 1;
				}
				else
				{
					if(CL_TRUEP(STACK(base, 14)))
					{
						COPY(STACK(base, 14), STACK(base, 28));
						LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 29)); /* PATHNAME */
						COPY(STACK(base, 14), STACK(base, 30));
						LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 31)); /* PATHNAME */
						struct_typep(STACK(base, 30));
						if(CL_TRUEP(STACK(base, 30)))
						{
						}
						else
						{
							COPY(SYMVAL(Slisp, 409), STACK(base, 30)); /* NO_STRUCT */
							COPY(STACK(base, 14), STACK(base, 31));
							LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 32)); /* PATHNAME */
							Ferror(STACK(base, 30), 3);
						}
						COPY(STACK(base, 14), STACK(base, 28));
						LOAD_FIXNUM(4, STACK(base, 29));
						struct_ref_internal(STACK(base, 28));
						COPY(STACK(base, 18), STACK(base, 29));
						maybe_diddle_case(STACK(base, 28));
						mv_count = 1;
					}
					else
					{
						LOAD_NIL(STACK(base, 28));
					}
				}
			}
		}
	}
	LOAD_SYMBOL(SYMBOL(Slisp, 190), STACK(base, 29)); /* VERSION */
	if(CL_TRUEP(STACK(base, 13)))
	{
		COPY(STACK(base, 5), STACK(base, 30));
	}
	else
	{
		if(CL_TRUEP(STACK(base, 14)))
		{
			COPY(STACK(base, 14), STACK(base, 30));
			LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 31)); /* PATHNAME */
			COPY(STACK(base, 14), STACK(base, 32));
			LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 33)); /* PATHNAME */
			struct_typep(STACK(base, 32));
			if(CL_TRUEP(STACK(base, 32)))
			{
			}
			else
			{
				COPY(SYMVAL(Slisp, 409), STACK(base, 32)); /* NO_STRUCT */
				COPY(STACK(base, 14), STACK(base, 33));
				LOAD_SYMBOL(SYMBOL(Slisp, 168), STACK(base, 34)); /* PATHNAME */
				Ferror(STACK(base, 32), 3);
			}
			COPY(STACK(base, 14), STACK(base, 30));
			LOAD_FIXNUM(5, STACK(base, 31));
			struct_ref_internal(STACK(base, 30));
		}
		else
		{
			LOAD_NIL(STACK(base, 30));
		}
	}
	Pmake_pathname(STACK(base, 19), 12);
	COPY(STACK(base, 19), STACK(base, 0));
}
