#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

CL_INIT Kunix_simplify_pathname[] =
{
{ CL_FIXNUM, 2 }, /* 0 */
{ RT_CHAR_PTR, (long)"./" },
{ CL_FIXNUM, 2 }, /* 2 */
{ RT_CHAR_PTR, (long)"./" },
};

void unix_simplify_pathname(CL_FORM *base)
{
	if(CL_CONSP(STACK(base, 0)) || CL_NILP(STACK(base, 0)))
	{
		COPY(STACK(base, 0), STACK(base, 1));
		raw_list_length(STACK(base, 1));
	}
	else
	{
		if(TYPE_OF(STACK(base, 0)) >= T_VEC_LO && TYPE_OF(STACK(base, 0)) <= T_VEC_HI)
		{
			LOAD_FIXNUM(AR_SIZE(GET_FORM(STACK(base, 0))), STACK(base, 1));
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KClisp[32], STACK(base, 1)); /* ~a is not a sequence */
			COPY(STACK(base, 0), STACK(base, 2));
			Ferror(STACK(base, 1), 2);
		}
	}
	COPY(STACK(base, 1), STACK(base, 2));
	Fmake_string(STACK(base, 2), 1);
	LOAD_FIXNUM(0, STACK(base, 3));
	LOAD_FIXNUM(0, STACK(base, 4));
	LOAD_NIL(STACK(base, 5));
	COPY(STACK(base, 1), STACK(base, 6));
	LOAD_FIXNUM(0, STACK(base, 7));
	M29_1:;
	COPY(STACK(base, 7), STACK(base, 8));
	COPY(STACK(base, 6), STACK(base, 9));
	Fge(STACK(base, 8), 2);
	if(CL_TRUEP(STACK(base, 8)))
	{
		goto RETURN32;
	}
	COPY(STACK(base, 0), STACK(base, 8));
	COPY(STACK(base, 7), STACK(base, 9));
	Fschar(STACK(base, 8));
	COPY(STACK(base, 8), STACK(base, 9));
	LOAD_CHAR('.', STACK(base, 10));
	FcharE(STACK(base, 9), 2);
	if(CL_TRUEP(STACK(base, 9)))
	{
		if(CL_TRUEP(STACK(base, 4)))
		{
			COPY(STACK(base, 4), STACK(base, 9));
			F1plus(STACK(base, 9));
			COPY(STACK(base, 9), STACK(base, 4));
		}
		COPY(STACK(base, 3), STACK(base, 9));
		COPY(STACK(base, 8), STACK(base, 10));
		COPY(STACK(base, 2), STACK(base, 11));
		COPY(STACK(base, 9), STACK(base, 12));
		Fset_schar(STACK(base, 10));
		COPY(STACK(base, 3), STACK(base, 9));
		F1plus(STACK(base, 9));
		COPY(STACK(base, 9), STACK(base, 3));
	}
	else
	{
		COPY(STACK(base, 8), STACK(base, 9));
		LOAD_CHAR('/', STACK(base, 10));
		FcharE(STACK(base, 9), 2);
		if(CL_TRUEP(STACK(base, 9)))
		{
			if(GET_FIXNUM(STACK(base, 4)) == 0 && CL_FIXNUMP(STACK(base, 4)))
			{
				if(CL_TRUEP(STACK(base, 5)))
				{
				}
				else
				{
					COPY(STACK(base, 3), STACK(base, 9));
					COPY(STACK(base, 9), STACK(base, 5));
					COPY(STACK(base, 3), STACK(base, 9));
					COPY(STACK(base, 8), STACK(base, 10));
					COPY(STACK(base, 2), STACK(base, 11));
					COPY(STACK(base, 9), STACK(base, 12));
					Fset_schar(STACK(base, 10));
					COPY(STACK(base, 3), STACK(base, 9));
					F1plus(STACK(base, 9));
					COPY(STACK(base, 9), STACK(base, 3));
				}
			}
			else
			{
				if(GET_FIXNUM(STACK(base, 4)) == 1 && CL_FIXNUMP(STACK(base, 4)))
				{
					COPY(STACK(base, 3), STACK(base, 9));
					F1minus(STACK(base, 9));
					COPY(STACK(base, 9), STACK(base, 3));
				}
				else
				{
					if(GET_FIXNUM(STACK(base, 4)) == 2 && CL_FIXNUMP(STACK(base, 4)))
					{
						if(CL_TRUEP(STACK(base, 5)))
						{
							COPY(STACK(base, 5), STACK(base, 9));
							Fzerop(STACK(base, 9));
							bool_result = NOT(CL_TRUEP(STACK(base, 9)));
						}
						else
						{
							bool_result = FALSE;
						}
						if(bool_result)
						{
							LOAD_CHAR('/', STACK(base, 9));
							COPY(STACK(base, 2), STACK(base, 10));
							LOAD_SYMBOL(SYMBOL(Slisp, 166), STACK(base, 11)); /* END */
							COPY(STACK(base, 5), STACK(base, 12));
							LOAD_SYMBOL(SYMBOL(Slisp, 233), STACK(base, 13)); /* FROM-END */
							LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 14)); /* T */
							Fposition(STACK(base, 9), 6);
							if(CL_TRUEP(STACK(base, 9)))
							{
								COPY(STACK(base, 9), STACK(base, 10));
							}
							else
							{
								LOAD_FIXNUM(0, STACK(base, 10));
							}
							LOAD_FIXNUM(2, STACK(base, 11));
							Fplus(STACK(base, 10), 2);
							COPY(STACK(base, 5), STACK(base, 11));
							Fnumeql(STACK(base, 10), 2);
							if(CL_TRUEP(STACK(base, 10)))
							{
								COPY(STACK(base, 2), STACK(base, 10));
								COPY(STACK(base, 5), STACK(base, 11));
								LOAD_FIXNUM(2, STACK(base, 12));
								Fminus(STACK(base, 11), 2);
								Fschar(STACK(base, 10));
								LOAD_CHAR('.', STACK(base, 11));
								FcharE(STACK(base, 10), 2);
								if(CL_TRUEP(STACK(base, 10)))
								{
									COPY(STACK(base, 2), STACK(base, 10));
									COPY(STACK(base, 5), STACK(base, 11));
									F1minus(STACK(base, 11));
									Fschar(STACK(base, 10));
									LOAD_CHAR('.', STACK(base, 11));
									FcharE(STACK(base, 10), 2);
									bool_result = CL_TRUEP(STACK(base, 10));
								}
								else
								{
									bool_result = FALSE;
								}
							}
							else
							{
								bool_result = FALSE;
							}
							if(bool_result)
							{
								COPY(STACK(base, 3), STACK(base, 10));
								COPY(STACK(base, 8), STACK(base, 11));
								COPY(STACK(base, 2), STACK(base, 12));
								COPY(STACK(base, 10), STACK(base, 13));
								Fset_schar(STACK(base, 11));
								COPY(STACK(base, 3), STACK(base, 10));
								F1plus(STACK(base, 10));
								COPY(STACK(base, 10), STACK(base, 3));
								COPY(STACK(base, 10), STACK(base, 5));
							}
							else
							{
								if(CL_TRUEP(STACK(base, 9)))
								{
									COPY(STACK(base, 9), STACK(base, 10));
									F1plus(STACK(base, 10));
								}
								else
								{
									LOAD_FIXNUM(0, STACK(base, 10));
								}
								COPY(STACK(base, 10), STACK(base, 3));
								COPY(STACK(base, 9), STACK(base, 5));
							}
						}
						else
						{
							COPY(STACK(base, 3), STACK(base, 9));
							COPY(STACK(base, 9), STACK(base, 5));
							COPY(STACK(base, 3), STACK(base, 9));
							COPY(STACK(base, 8), STACK(base, 10));
							COPY(STACK(base, 2), STACK(base, 11));
							COPY(STACK(base, 9), STACK(base, 12));
							Fset_schar(STACK(base, 10));
							COPY(STACK(base, 3), STACK(base, 9));
							F1plus(STACK(base, 9));
							COPY(STACK(base, 9), STACK(base, 3));
						}
					}
					else
					{
						COPY(STACK(base, 3), STACK(base, 9));
						COPY(STACK(base, 9), STACK(base, 5));
						COPY(STACK(base, 3), STACK(base, 9));
						COPY(STACK(base, 8), STACK(base, 10));
						COPY(STACK(base, 2), STACK(base, 11));
						COPY(STACK(base, 9), STACK(base, 12));
						Fset_schar(STACK(base, 10));
						COPY(STACK(base, 3), STACK(base, 9));
						F1plus(STACK(base, 9));
						COPY(STACK(base, 9), STACK(base, 3));
					}
				}
			}
			LOAD_FIXNUM(0, STACK(base, 4));
		}
		else
		{
			LOAD_NIL(STACK(base, 4));
			COPY(STACK(base, 3), STACK(base, 9));
			COPY(STACK(base, 8), STACK(base, 10));
			COPY(STACK(base, 2), STACK(base, 11));
			COPY(STACK(base, 9), STACK(base, 12));
			Fset_schar(STACK(base, 10));
			COPY(STACK(base, 3), STACK(base, 9));
			F1plus(STACK(base, 9));
			COPY(STACK(base, 9), STACK(base, 3));
		}
	}
	F1plus(STACK(base, 7));
	goto M29_1;
	RETURN32:;
	if(CL_TRUEP(STACK(base, 5)))
	{
		COPY(STACK(base, 5), STACK(base, 6));
		Fzerop(STACK(base, 6));
		bool_result = NOT(CL_TRUEP(STACK(base, 6)));
	}
	else
	{
		bool_result = FALSE;
	}
	if(bool_result)
	{
		if(GET_FIXNUM(STACK(base, 4)) == 1 && CL_FIXNUMP(STACK(base, 4)))
		{
			COPY(STACK(base, 3), STACK(base, 6));
			F1minus(STACK(base, 6));
			COPY(STACK(base, 6), STACK(base, 3));
		}
		else
		{
			if(GET_FIXNUM(STACK(base, 4)) == 2 && CL_FIXNUMP(STACK(base, 4)))
			{
				COPY(STACK(base, 5), STACK(base, 6));
				LOAD_FIXNUM(2, STACK(base, 7));
				Fge(STACK(base, 6), 2);
				if(CL_TRUEP(STACK(base, 6)))
				{
					COPY(STACK(base, 2), STACK(base, 6));
					COPY(STACK(base, 5), STACK(base, 7));
					F1minus(STACK(base, 7));
					Fschar(STACK(base, 6));
					LOAD_CHAR('.', STACK(base, 7));
					FcharE(STACK(base, 6), 2);
					if(CL_TRUEP(STACK(base, 6)))
					{
						COPY(STACK(base, 2), STACK(base, 6));
						COPY(STACK(base, 5), STACK(base, 7));
						LOAD_FIXNUM(2, STACK(base, 8));
						Fminus(STACK(base, 7), 2);
						Fschar(STACK(base, 6));
						LOAD_CHAR('.', STACK(base, 7));
						FcharE(STACK(base, 6), 2);
						if(CL_TRUEP(STACK(base, 6)))
						{
							COPY(STACK(base, 5), STACK(base, 6));
							LOAD_FIXNUM(2, STACK(base, 7));
							Fnumeql(STACK(base, 6), 2);
							if(CL_TRUEP(STACK(base, 6)))
							{
								bool_result = TRUE;
							}
							else
							{
								COPY(STACK(base, 2), STACK(base, 7));
								COPY(STACK(base, 5), STACK(base, 8));
								LOAD_FIXNUM(3, STACK(base, 9));
								Fminus(STACK(base, 8), 2);
								Fschar(STACK(base, 7));
								LOAD_CHAR('/', STACK(base, 8));
								FcharE(STACK(base, 7), 2);
								bool_result = CL_TRUEP(STACK(base, 7));
							}
						}
						else
						{
							bool_result = FALSE;
						}
					}
					else
					{
						bool_result = FALSE;
					}
				}
				else
				{
					bool_result = FALSE;
				}
				if(bool_result)
				{
				}
				else
				{
					LOAD_CHAR('/', STACK(base, 6));
					COPY(STACK(base, 2), STACK(base, 7));
					LOAD_SYMBOL(SYMBOL(Slisp, 166), STACK(base, 8)); /* END */
					COPY(STACK(base, 5), STACK(base, 9));
					LOAD_SYMBOL(SYMBOL(Slisp, 233), STACK(base, 10)); /* FROM-END */
					LOAD_SYMBOL(SYMBOL(Ssys, 1), STACK(base, 11)); /* T */
					Fposition(STACK(base, 6), 6);
					if(CL_TRUEP(STACK(base, 6)))
					{
						COPY(STACK(base, 6), STACK(base, 7));
						F1plus(STACK(base, 7));
						COPY(STACK(base, 7), STACK(base, 3));
					}
					else
					{
						LOAD_SMSTR((CL_FORM *)&Kunix_simplify_pathname[0], STACK(base, 0)); /* ./ */
						goto RETURN31;
					}
				}
			}
		}
	}
	COPY(STACK(base, 3), STACK(base, 6));
	Fzerop(STACK(base, 6));
	if(CL_TRUEP(STACK(base, 6)))
	{
		LOAD_SMSTR((CL_FORM *)&Kunix_simplify_pathname[2], STACK(base, 0)); /* ./ */
	}
	else
	{
		COPY(STACK(base, 3), STACK(base, 6));
		COPY(STACK(base, 1), STACK(base, 7));
		Fnumeql(STACK(base, 6), 2);
		if(CL_TRUEP(STACK(base, 6)))
		{
			COPY(STACK(base, 2), STACK(base, 0));
		}
		else
		{
			COPY(STACK(base, 2), STACK(base, 0));
			LOAD_FIXNUM(0, STACK(base, 1));
			COPY(STACK(base, 3), STACK(base, 2));
			Fsubseq(STACK(base, 0), 3);
		}
	}
	RETURN31:;
}
