#include <c_decl.h>
#include "sys.h"
#include "lisp.h"

CL_INIT KFmake_hash_table[] =
{
{ CL_FIXNUM, 57 }, /* 0 */
{ RT_CHAR_PTR, (long)"test ~a in make-hash-table should be a function or symbol" },
{ CL_FIXNUM, 51 }, /* 2 */
{ RT_CHAR_PTR, (long)"rehash-size ~A is not a floating-point number > 1.0" },
{ CL_FIXNUM, 56 }, /* 4 */
{ RT_CHAR_PTR, (long)"rehash-size ~A is not a floating-point number or integer" },
{ CL_FIXNUM, 80 }, /* 6 */
{ RT_CHAR_PTR, (long)"rehash-threshold ~A is not a floating-point ~\n            number between 0 and 1" },
};

static void Z97_prime_ceiling(CL_FORM *base);

void Fmake_hash_table(CL_FORM *base, int nargs)
{
	BOOL supl_flags[4];
	static CL_FORM * keylist[] =
	{
		SYMBOL(Slisp, 217), /* TEST */
		SYMBOL(Slisp, 418), /* SIZE */
		SYMBOL(Slisp, 419), /* REHASH-SIZE */
		SYMBOL(Slisp, 420), /* REHASH-THRESHOLD */
	};
	keysort(STACK(base, 0), nargs - 0, 4, keylist, supl_flags, FALSE);
	if(NOT(supl_flags[0]))
	{
		static GLOBAL_FUNARG extern_closure = {Feql, 2};
		LOAD_GLOBFUN(&extern_closure, STACK(base, 0));
	}
	if(NOT(supl_flags[1]))
	{
		LOAD_FIXNUM(50, STACK(base, 1));
	}
	if(NOT(supl_flags[2]))
	{
		static double local_float = 1.5;
		LOAD_FLOAT(&local_float, STACK(base, 2));
	}
	if(NOT(supl_flags[3]))
	{
		static double local_float = 0.7;
		LOAD_FLOAT(&local_float, STACK(base, 3));
	}
	if(CL_SYMBOLP(STACK(base, 0)) || CL_NILP(STACK(base, 0)))
	{
		if(GET_SYMBOL(STACK(base, 0)) == SYMBOL(Slisp, 422) && CL_SYMBOLP(STACK(base, 0))) /* EQ */
		{
			static GLOBAL_FUNARG extern_closure = {Feq, 2};
			LOAD_GLOBFUN(&extern_closure, STACK(base, 0));
		}
		else
		{
			if(GET_SYMBOL(STACK(base, 0)) == SYMBOL(Slisp, 423) && CL_SYMBOLP(STACK(base, 0))) /* EQL */
			{
				static GLOBAL_FUNARG extern_closure = {Feql, 2};
				LOAD_GLOBFUN(&extern_closure, STACK(base, 0));
			}
			else
			{
				if(GET_SYMBOL(STACK(base, 0)) == SYMBOL(Slisp, 424) && CL_SYMBOLP(STACK(base, 0))) /* EQUAL */
				{
					LOAD_GLOBFUN(&CFequal, STACK(base, 0));
				}
				else
				{
					if(GET_SYMBOL(STACK(base, 0)) == SYMBOL(Slisp, 425) && CL_SYMBOLP(STACK(base, 0))) /* EQUALP */
					{
						LOAD_GLOBFUN(&CFequalp, STACK(base, 0));
					}
				}
			}
		}
	}
	else
	{
		if(CL_CLOSUREP(STACK(base, 0)) || CL_DOWNFUNP(STACK(base, 0)) || CL_GLOBFUNP(STACK(base, 0)))
		{
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KFmake_hash_table[0], STACK(base, 4)); /* test ~a in make-hash-table should be a function or symbol */
			COPY(STACK(base, 0), STACK(base, 5));
			Ferror(STACK(base, 4), 2);
		}
	}
	if(CL_FIXNUMP(STACK(base, 2)))
	{
		static double local_float = 1.0;
		LOAD_FLOAT(&local_float, STACK(base, 4));
		COPY(STACK(base, 1), STACK(base, 5));
		COPY(STACK(base, 2), STACK(base, 6));
		Fdiv(STACK(base, 5), 2);
		Fplus(STACK(base, 4), 2);
		COPY(STACK(base, 4), STACK(base, 2));
	}
	else
	{
		if(CL_FLOATP(STACK(base, 2)))
		{
			static double local_float = 1.0;
			LOAD_FLOAT(&local_float, STACK(base, 4));
			COPY(STACK(base, 2), STACK(base, 5));
			Fge(STACK(base, 4), 2);
			if(CL_TRUEP(STACK(base, 4)))
			{
				LOAD_SMSTR((CL_FORM *)&KFmake_hash_table[2], STACK(base, 4)); /* rehash-size ~A is not a floating-point number > 1.0 */
				COPY(STACK(base, 2), STACK(base, 5));
				Ferror(STACK(base, 4), 2);
			}
		}
		else
		{
			LOAD_SMSTR((CL_FORM *)&KFmake_hash_table[4], STACK(base, 4)); /* rehash-size ~A is not a floating-point number or integer */
			COPY(STACK(base, 2), STACK(base, 5));
			Ferror(STACK(base, 4), 2);
		}
	}
	if(CL_FLOATP(STACK(base, 3)))
	{
		COPY(STACK(base, 3), STACK(base, 4));
		{
			static double local_float = 0.0;
			LOAD_FLOAT(&local_float, STACK(base, 5));
		}
		Fge(STACK(base, 4), 2);
		if(CL_TRUEP(STACK(base, 4)))
		{
			COPY(STACK(base, 3), STACK(base, 4));
			{
				static double local_float = 1.0;
				LOAD_FLOAT(&local_float, STACK(base, 5));
			}
			Fle(STACK(base, 4), 2);
			bool_result = CL_TRUEP(STACK(base, 4));
		}
		else
		{
			bool_result = FALSE;
		}
	}
	else
	{
		bool_result = FALSE;
	}
	if(bool_result)
	{
	}
	else
	{
		LOAD_SMSTR((CL_FORM *)&KFmake_hash_table[6], STACK(base, 4)); /* rehash-threshold ~A is not a floating-point ~
            number between 0 and 1 */
		COPY(STACK(base, 3), STACK(base, 5));
		Ferror(STACK(base, 4), 2);
	}
	COPY(STACK(base, 1), STACK(base, 4));
	Z97_prime_ceiling(STACK(base, 4));
	LOAD_SYMBOL(SYMBOL(Slisp, 418), STACK(base, 5)); /* SIZE */
	COPY(STACK(base, 4), STACK(base, 6));
	LOAD_SYMBOL(SYMBOL(Slisp, 392), STACK(base, 7)); /* COUNT */
	LOAD_FIXNUM(0, STACK(base, 8));
	LOAD_SYMBOL(SYMBOL(Slisp, 419), STACK(base, 9)); /* REHASH-SIZE */
	COPY(STACK(base, 2), STACK(base, 10));
	LOAD_SYMBOL(SYMBOL(Slisp, 420), STACK(base, 11)); /* REHASH-THRESHOLD */
	COPY(STACK(base, 3), STACK(base, 12));
	LOAD_SYMBOL(SYMBOL(Slisp, 217), STACK(base, 13)); /* TEST */
	COPY(STACK(base, 0), STACK(base, 14));
	LOAD_SYMBOL(SYMBOL(Slisp, 421), STACK(base, 15)); /* ARRAY */
	COPY(STACK(base, 4), STACK(base, 16));
	LOAD_SYMBOL(SYMBOL(Slisp, 124), STACK(base, 17)); /* INITIAL-ELEMENT */
	LOAD_NIL(STACK(base, 18));
	Fmake_array(STACK(base, 16), 3);
	new_hash_table(STACK(base, 5), 12);
	COPY(STACK(base, 5), STACK(base, 0));
}

static void Z97_prime_ceiling(CL_FORM *base)
{
	COPY(STACK(base, 0), STACK(base, 1));
	LOAD_FIXNUM(2, STACK(base, 2));
	COPY(STACK(base, 1), STACK(base, 3));
	LOAD_FIXNUM(2, STACK(base, 4));
	truncate_internal(STACK(base, 3));
	COPY(&mv_buf[0], STACK(base, 4));
	mv_count = 1;
	COPY(STACK(base, 4), STACK(base, 1));
	Fzerop(STACK(base, 1));
	if(CL_TRUEP(STACK(base, 1)))
	{
		F1plus(STACK(base, 0));
	}
	COPY(STACK(base, 0), STACK(base, 1));
	LOAD_FIXNUM(3, STACK(base, 2));
	COPY(STACK(base, 1), STACK(base, 3));
	LOAD_FIXNUM(3, STACK(base, 4));
	truncate_internal(STACK(base, 3));
	COPY(&mv_buf[0], STACK(base, 4));
	mv_count = 1;
	COPY(STACK(base, 4), STACK(base, 1));
	Fzerop(STACK(base, 1));
	if(CL_TRUEP(STACK(base, 1)))
	{
		LOAD_FIXNUM(2, STACK(base, 1));
		COPY(STACK(base, 0), STACK(base, 2));
		Fplus(STACK(base, 1), 2);
		COPY(STACK(base, 1), STACK(base, 0));
	}
	COPY(STACK(base, 0), STACK(base, 1));
	LOAD_FIXNUM(5, STACK(base, 2));
	COPY(STACK(base, 1), STACK(base, 3));
	LOAD_FIXNUM(5, STACK(base, 4));
	truncate_internal(STACK(base, 3));
	COPY(&mv_buf[0], STACK(base, 4));
	mv_count = 1;
	COPY(STACK(base, 4), STACK(base, 1));
	Fzerop(STACK(base, 1));
	if(CL_TRUEP(STACK(base, 1)))
	{
		LOAD_FIXNUM(4, STACK(base, 1));
		COPY(STACK(base, 0), STACK(base, 2));
		Fplus(STACK(base, 1), 2);
		COPY(STACK(base, 1), STACK(base, 0));
	}
}
